// Generated by ParserBuilder @ 27/05/2001 7:36:01 PM

unit DelphiParser;

(* NOTE: Any changes made to this file may be overwritten when it gets regenerated
  from within ParserBuilder - unless you run the Delphi Import command*)


interface

uses
  Windows, Messages, SysUtils, Classes,Win32OnlyComponent, DelphiScanner;


const
  maxT = 128;
  minErrDist = 2;  (* minimal distance (good tokens) between two errors *)
  setsize = 16;  (* sets are stored in 16 bits *)

type
  BITSET = set of 0..15;
  TSymbolSet = array [0..maxT div  setsize] of BITSET;

{PBGLOBAL}

{ENDPBGLOBAL}


// This is a test of the backup system


type
  TDelphiParser = class(TDelphiScanner)
  private
    FSuccessful: boolean;
    {PBPRIVATE}
    fOutputStream : TStringStream;
 fCollectStart : Integer;
 fCollectLength : Integer;
 procedure Init;
 procedure Final;
 Function CalcLength : Integer;
 procedure SetStart;
 function CopySourceToCurrent : String;
 procedure WriteStr(S : string);
 Function GetLexString : String;
 procedure ReportError(nr, line, col, pos: integer);

    {ENDPBPRIVATE}
    procedure PerformGet;
    procedure SynError(errNo: integer);
    procedure SemError(errNo: integer);
    function _In(var s: TSymbolSet; x: integer): boolean;
    procedure Expect(n: integer);
    procedure ExpectWeak(n, follow: integer);
    function WeakSeparator(n, syFol, repFol: integer): boolean;
    function GetSuccessful: boolean;
    Procedure SetSourceString(const Value : String);
        Procedure _ReusableWords;
    Procedure _UnitId;
    Procedure _TypedConstantBody;
    Procedure _GUIDDef;
    Procedure _ConstantDecl;
    Procedure _EnumeratedTypeElement;
    Procedure _ClassRefBody;
    Procedure _Parameter;
    Procedure _TypedConstant;
    Procedure _String;
    Procedure _NumberList;
    Procedure _HexNumber;
    Procedure _IdentTypes;
    Procedure _VariantType;
    Procedure _ProcedureType;
    Procedure _StringType;
    Procedure _RealType;
    Procedure _OrdIdent;
    Procedure _EnumeratedType;
    Procedure _ObjField;
    Procedure _FormalParameters;
    Procedure _PointerType;
    Procedure _SubrangeType;
    Procedure _VarDecl;
    Procedure _RecField;
    Procedure _CaseItem;
    Procedure _RecItem;
    Procedure _MulOp;
    Procedure _AddOp;
    Procedure _Number;
    Procedure _ConstantDeclBody;
    Procedure _RecType;
    Procedure _FileType;
    Procedure _SetType;
    Procedure _ArrayType;
    Procedure _StrucType;
    Procedure _DestructorHeading;
    Procedure _ConstructorHeading;
    Procedure _FunctionHeading;
    Procedure _ProcedureHeading;
    Procedure _MethodHeading;
    Procedure _Method;
    Procedure _AccessSettings;
    Procedure _Property;
    Procedure _PropertyList;
    Procedure _Type;
    Procedure _PropertyInterface;
    Procedure _FormalParm;
    Procedure _PropertyParameterList;
    Procedure _ObjHeritage;
    Procedure _PropertySpecifiers;
    Procedure _ObjFieldList;
    Procedure _MethodList;
    Procedure _ClassFieldList;
    Procedure _ClassHeritage;
    Procedure _ClassTypeBody;
    Procedure _IdentList;
    Procedure _ClassPropertyList;
    Procedure _ClassMethodList;
    Procedure _GUID;
    Procedure _InterfaceHeritage;
    Procedure _InterfaceType;
    Procedure _ObjectType;
    Procedure _ConstExpr;
    Procedure _NumberTypes;
    Procedure _ClassTypeGroup;
    Procedure _RestrictedType;
    Procedure _TypeId;
    Procedure _TypeDecl;
    Procedure _ResourceString;
    Procedure _ExportedHeading;
    Procedure _VarSection;
    Procedure _TypeSection;
    Procedure _ConstSection;
    Procedure _InterfaceDecl;
    Procedure _UsesClause;
    Procedure _ImplementationSection;
    Procedure _InterfaceSection;
    Procedure _Directive;
    Procedure _BadNames;
    Procedure _Ident;
    Procedure _Unit;
    Procedure _SourceFile;
    Procedure _Delphi;


  protected
    {PBPROTECTED}
     
    {ENDPBPROTECTED}
  public
    {PBPUBLIC}
    
    {ENDPBPUBLIC}
    constructor Create;
    destructor Destroy; override;
    procedure Parse;
    procedure LexString(var Lex: string);
    procedure LexName(var Lex: string);
    procedure LookAheadString(var Lex: string);
    procedure LookAheadName(var Lex: string);
  published
    property Successful: boolean read GetSuccessful;
    Property SourceString : String write SetSourceString;
    {PBPUBLISHED}
    
    {ENDPBPUBLISHED}
  end;

implementation

var
  symSet: array [0..34] of TSymbolSet;
  errDist: integer;
  sym: integer;

{  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-
   + For ParserBuilder's Delphi import function to work,        -
   + you must place your code in this Arbitrary Source section. -
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+- }

{PBARBITRARYSOURCE}


Procedure TDelphiParser.SetStart;
Begin
 fCollectStart := nextPos+1;
End;

procedure TDelphiParser.Init;
begin
 fOutputStream.Size := 0;
 fCollectStart := 0;
 fCollectLength := 0;
 lst.Size := 0;
end;

Function TDelphiParser.CopySourceToCurrent : String;
Begin
 CalcLength;
 Result := Copy(src.DataString, FCollectStart, fCollectLength);
End;

Function TDelphiParser.CalcLength : Integer;
Begin
 Result := nextPos - fCollectStart+1;
 fCollectLength := Result;
End;

procedure TDelphiParser.Final;
begin
 if Errors>0 then
  lst.WriteString('*** Errors ***' +#13#10 );
 lst.WriteString(fOutputStream.DataString);
 fOutputStream.Size := 0;
end;

procedure TDelphiParser.WriteStr(S : string);
begin
 fOutputStream.WriteBuffer(S[1],length(S));
end;

Function TDelphiParser.GetLexString : String;
Begin
 LexString(Result);
end;

procedure TDelphiParser.ReportError(nr, line, col, pos: integer);
Var
 S, S1 : String;
 SL : TStringList;
begin
 Case nr of
 {$I  Delphi.err}
 End; // Case
 S := CRLF +S+CRLF + 'Line ' +IntToStr(line)+CRLF+'Column ' +
   IntToStr(col)+CRLF+'................................' +CRLF;
 SL := TStringList.Create;
 SL.Text := src.DataString;
 if Line<SL.Count then
   S1 := SL[Line-1]
  else S1 := '[End Of Source File]' ;
 SL.Free;
 Insert(' ERROR->' ,S1,Col-1);
 Inc(fErrors);
 WriteStr(S+S1+CRLF);
end;




{ENDPBARBITRARYSOURCE}

 { TDelphiParser - Generated Methods below}
procedure TDelphiParser.SemError(errNo: integer);
begin
  if errDist >= minErrDist then
  begin
     Error(errNo, line, col, pos);
  end;
  errDist := 0;
end;

procedure TDelphiParser.SynError(errNo: integer);
begin
  if errDist >= minErrDist then
  begin
     Error(errNo, nextLine, nextCol, nextPos);
  end;
  errDist := 0;
end;

procedure TDelphiParser.PerformGet;
var
  s: string;
begin
  repeat
    Get(sym);
    if sym <= maxT then
      INC(errDist)
    else
    begin
     
    end;
  until sym <= maxT
  end;

function TDelphiParser._In(var s: TSymbolSet; x: integer): boolean;
begin
  _In := x mod setsize in s[x div setsize];
end;

function TDelphiParser.GetSuccessful: boolean;
begin
  FSuccessful := errors = 0;
  Result := FSuccessful;
end;

procedure TDelphiParser.Expect(n: integer);
begin
  if Sym = n then PerformGet
  else
    SynError(n);
end;

procedure TDelphiParser.ExpectWeak(n, follow: integer);
begin
  if Sym = n then PerformGet
  else
  begin
    SynError(n);
    while not _In(symSet[follow], Sym) do PerformGet;
  end
end;

function TDelphiParser.WeakSeparator(n, syFol, repFol: integer): boolean;
var
  s: TSymbolSet;
  i: integer;
begin
  if sym = n then
  begin
    PerformGet;
    WeakSeparator := True;
    EXIT;
  end
  else if _In(symSet[repFol], sym) then
  begin
    WeakSeparator := False;
    exit
  end
  else
  begin
    i := 0;
    while i <= maxT div setsize do
    begin
      s[i] := symSet[0, i] + symSet[syFol, i] + symSet[repFol, i];
      INC(i)
    end;
    SynError(n);
    while not _In(s, sym) do PerformGet;
    WeakSeparator := _In(symSet[syFol], sym)
  end
end;

procedure TDelphiParser.LexName(var Lex: string);
begin
    GetName(pos, len, Lex)
end;

procedure TDelphiParser.LexString(var Lex: string);
begin
   GetString(pos, len, Lex)
end;

procedure TDelphiParser.LookAheadName(var Lex: string);
begin
  GetName(nextPos, nextLen, Lex);
end;

procedure TDelphiParser.LookAheadString(var Lex: string);
begin
  GetString(nextPos, nextLen, Lex)
end;

Procedure TDelphiParser.SetSourceString(const Value : String);
Var sWin32Code : String;
Begin
  if (src<> NIL) then
    src.Free;
  ExecuteWin32OnlyParser(Value,sWin32Code);
  src := TStringStream.Create(sWin32Code);
  //src := TStringStream.Create(Value);
End;
Procedure TDelphiParser._ReusableWords;
  BEGIN
    IF (sym = 24) THEN BEGIN
      PerformGet;
    END ELSE IF (sym = 26) THEN BEGIN
      PerformGet;
    END ELSE IF _In(symSet[1], sym) THEN BEGIN
      _Directive;
    END ELSE IF (sym = 23) THEN BEGIN
      PerformGet;
    END ELSE IF (sym = 28) THEN BEGIN
      PerformGet;
    END ELSE BEGIN SynError(129);
    END;
  END;

Procedure TDelphiParser._UnitId;
  BEGIN
    _Ident;
  END;

Procedure TDelphiParser._TypedConstantBody;
  BEGIN
    IF (sym = 17) THEN BEGIN
      //WriteStr( 'In Typed ConstantBody ->' +#13#10) ;
      PerformGet;
      IF (sym = 2) OR (sym = 4) OR (sym = 5) OR (sym = 54) OR (sym = 55) THEN BEGIN
        _NumberList;
      END ELSE IF _In(symSet[2], sym) THEN BEGIN
        _VarDecl;
        WHILE (sym = 8) DO BEGIN
          PerformGet;
          _VarDecl;
        END;
      END ELSE BEGIN SynError(130);
      END;
      Expect(18);
    END ELSE IF _In(symSet[3], sym) THEN BEGIN
      IF (sym = 2) OR (sym = 4) OR (sym = 5) OR (sym = 54) OR (sym = 55) THEN BEGIN
        _NumberList;
      END ELSE IF (sym = 15) THEN BEGIN
        PerformGet;
        _IdentList;
        Expect(16);
        WHILE (sym = 31) OR (sym = 52) DO BEGIN
          IF (sym = 31) THEN BEGIN
            PerformGet;
          END ELSE BEGIN
            PerformGet;
          END;
          Expect(15);
          _IdentList;
          Expect(16);
        END;
      END ELSE IF _In(symSet[4], sym) THEN BEGIN
        _GUIDDef;
      END ELSE IF (sym = 3) OR (sym = 118) THEN BEGIN
        _String;
        WHILE (sym = 31) OR (sym = 52) DO BEGIN
          IF (sym = 31) THEN BEGIN
            PerformGet;
          END ELSE BEGIN
            PerformGet;
          END;
          _ConstExpr;
        END;
      END ELSE IF _In(symSet[2], sym) THEN BEGIN
        _IdentList;
      END ELSE BEGIN SynError(131);
      END;
      IF (sym = 32) THEN BEGIN
        PerformGet;
        IF _In(symSet[5], sym) THEN BEGIN
          _ConstExpr;
        END ELSE IF (sym = 3) OR (sym = 118) THEN BEGIN
          _String;
        END ELSE BEGIN SynError(132);
        END;
      END;
    END ELSE BEGIN SynError(133);
    END;
  END;

Procedure TDelphiParser._GUIDDef;
  BEGIN
    IF _In(symSet[6], sym) THEN BEGIN
      //WriteStr( 'In GUIDDef' +#13#10) ;
      IF (sym = 121) THEN BEGIN
        PerformGet;
        Expect(32);
        Expect(17);
        Expect(120);
        Expect(32);
        Expect(17);
        Expect(124);
        Expect(32);
        _NumberTypes;
        Expect(8);
        Expect(125);
        Expect(32);
        _NumberTypes;
        Expect(8);
        Expect(126);
        Expect(32);
        _NumberTypes;
        Expect(8);
        Expect(127);
        Expect(32);
        Expect(17);
        _NumberTypes;
        WHILE (sym = 31) DO BEGIN
          PerformGet;
          _NumberTypes;
        END;
        Expect(18);
        Expect(18);
        Expect(18);
        Expect(8);
        Expect(122);
        Expect(32);
        _Ident;
        Expect(8);
        Expect(123);
        Expect(32);
        Expect(17);
        Expect(119);
        Expect(32);
        _NumberTypes;
        Expect(18);
      END;
    END ELSE IF (sym = 124) THEN BEGIN
      PerformGet;
      Expect(32);
      _NumberTypes;
      Expect(8);
      Expect(125);
      Expect(32);
      _NumberTypes;
      Expect(8);
      Expect(126);
      Expect(32);
      _NumberTypes;
      Expect(8);
      Expect(127);
      Expect(32);
      Expect(17);
      _NumberTypes;
      WHILE (sym = 31) DO BEGIN
        PerformGet;
        _NumberTypes;
      END;
      Expect(18);
    END ELSE BEGIN SynError(134);
    END;
  END;

Procedure TDelphiParser._ConstantDecl;
  BEGIN
    IF _In(symSet[7], sym) THEN BEGIN
      _BadNames;
    END ELSE IF _In(symSet[8], sym) THEN BEGIN
      _Ident;
    END ELSE BEGIN SynError(135);
    END;
    //WriteStr( 'Constant Name = ' +GetLexString+#13#10) ;
    IF (sym = 11) THEN BEGIN
      PerformGet;
      IF (sym = 58) THEN BEGIN
        PerformGet;
      END;
      _ConstantDeclBody;
    END ELSE IF (sym = 32) THEN BEGIN
      PerformGet;
      _Type;
      Expect(11);
      IF (sym = 58) THEN BEGIN
        PerformGet;
      END;
      IF (sym = 3) OR (sym = 118) THEN BEGIN
        _String;
      END ELSE IF (sym = 77) OR (sym = 81) OR (sym = 111) THEN BEGIN
        IF (sym = 77) THEN BEGIN
          PerformGet;
        END ELSE IF (sym = 81) THEN BEGIN
          PerformGet;
        END ELSE BEGIN
          PerformGet;
        END;
        Expect(17);
        _TypedConstant;
        Expect(18);
      END ELSE IF (sym = 15) THEN BEGIN
        PerformGet;
        WriteStr( 'Entering TypedConstant 0 from ConstDecl' +#13#10) ;
        _ConstExpr;
        WHILE _In(symSet[9], sym) DO BEGIN
          IF (sym = 52) OR (sym = 54) OR (sym = 55) OR (sym = 70) THEN BEGIN
            _AddOp;
          END ELSE BEGIN
            _MulOp;
          END;
          _ConstExpr;
        END;
        Expect(16);
        IF (sym = 52) OR (sym = 54) OR (sym = 55) OR (sym = 70) THEN BEGIN
          _AddOp;
          Expect(15);
          _ConstExpr;
          WHILE _In(symSet[9], sym) DO BEGIN
            IF (sym = 52) OR (sym = 54) OR (sym = 55) OR (sym = 70) THEN BEGIN
              _AddOp;
            END ELSE BEGIN
              _MulOp;
            END;
            _ConstExpr;
          END;
          Expect(16);
        END;
      END ELSE IF _In(symSet[10], sym) THEN BEGIN
        WriteStr( 'Entering TypedConstant 1 from ConstDecl' +#13#10) ;
        _TypedConstant;
      END ELSE BEGIN SynError(136);
      END;
    END ELSE BEGIN SynError(137);
    END;
  END;

Procedure TDelphiParser._EnumeratedTypeElement;
  BEGIN
    IF (sym = 77) THEN BEGIN
      PerformGet;
      Expect(17);
      IF _In(symSet[8], sym) THEN BEGIN
        _Ident;
      END ELSE IF (sym = 3) OR (sym = 118) THEN BEGIN
        _String;
      END ELSE BEGIN SynError(138);
      END;
      Expect(18);
      WHILE _In(symSet[9], sym) DO BEGIN
        IF (sym = 52) OR (sym = 54) OR (sym = 55) OR (sym = 70) THEN BEGIN
          _AddOp;
        END ELSE BEGIN
          _MulOp;
        END;
        _ConstExpr;
      END;
    END ELSE IF _In(symSet[8], sym) THEN BEGIN
      _Ident;
      IF (sym = 11) THEN BEGIN
        PerformGet;
        _ConstExpr;
      END;
    END ELSE BEGIN SynError(139);
    END;
  END;

Procedure TDelphiParser._ClassRefBody;
  BEGIN
    Expect(39);
    _TypeId;
  END;

Procedure TDelphiParser._Parameter;
  BEGIN
    //WriteStr( ' In Parameter ->' +#13#10) ;
    _IdentList;
    IF (sym = 32) THEN BEGIN
      PerformGet;
      IF (sym = 38) THEN BEGIN
        PerformGet;
        Expect(39);
      END;
      IF _In(symSet[11], sym) THEN BEGIN
        _Type;
      END ELSE IF (sym = 40) THEN BEGIN
        PerformGet;
      END ELSE BEGIN SynError(140);
      END;
    END;
    IF (sym = 11) THEN BEGIN
      PerformGet;
      _ConstExpr;
    END;
  END;

Procedure TDelphiParser._TypedConstant;
  BEGIN
    IF (sym = 17) THEN BEGIN
      //WriteStr( 'In Typed Constant ->' +#13#10) ;
      PerformGet;
      _TypedConstantBody;
      WHILE _In(symSet[12], sym) DO BEGIN
        IF (sym = 8) THEN BEGIN
          PerformGet;
        END ELSE IF (sym = 52) THEN BEGIN
          PerformGet;
        END ELSE IF (sym = 31) THEN BEGIN
          PerformGet;
        END ELSE IF (sym = 52) OR (sym = 54) OR (sym = 55) OR (sym = 70) THEN BEGIN
          _AddOp;
        END ELSE BEGIN
          _MulOp;
        END;
        _TypedConstantBody;
      END;
      Expect(18);
    END ELSE IF (sym = 15) THEN BEGIN
      PerformGet;
      _ConstExpr;
      Expect(16);
      WHILE (sym = 8) OR (sym = 52) DO BEGIN
        IF (sym = 8) THEN BEGIN
          PerformGet;
        END ELSE BEGIN
          PerformGet;
        END;
        Expect(15);
        _ConstExpr;
        Expect(16);
      END;
    END ELSE IF _In(symSet[13], sym) THEN BEGIN
      _TypedConstantBody;
    END ELSE BEGIN SynError(141);
    END;
  END;

Procedure TDelphiParser._String;
  BEGIN
    IF (sym = 3) THEN BEGIN
      PerformGet;
      WHILE (sym = 3) OR (sym = 6) OR (sym = 54) DO BEGIN
        IF (sym = 3) THEN BEGIN
          PerformGet;
        END ELSE IF (sym = 6) THEN BEGIN
          PerformGet;
          WHILE (sym = 6) DO BEGIN
            PerformGet;
          END;
        END ELSE BEGIN
          PerformGet;
          IF _In(symSet[8], sym) THEN BEGIN
            _Ident;
          END;
        END;
      END;
    END ELSE IF (sym = 118) THEN BEGIN
      PerformGet;
      Expect(2);
    END ELSE BEGIN SynError(142);
    END;
  END;

Procedure TDelphiParser._NumberList;
  BEGIN
    _NumberTypes;
    WHILE (sym = 31) OR (sym = 52) DO BEGIN
      IF (sym = 31) THEN BEGIN
        PerformGet;
      END ELSE BEGIN
        PerformGet;
      END;
      IF (sym = 2) OR (sym = 4) OR (sym = 5) OR (sym = 54) OR (sym = 55) THEN BEGIN
        _NumberTypes;
      END ELSE IF _In(symSet[5], sym) THEN BEGIN
        _ConstExpr;
      END ELSE BEGIN SynError(143);
      END;
    END;
  END;

Procedure TDelphiParser._HexNumber;
  BEGIN
    IF (sym = 54) OR (sym = 55) THEN BEGIN
      IF (sym = 54) THEN BEGIN
        PerformGet;
      END ELSE BEGIN
        PerformGet;
      END;
    END;
    Expect(5);
  END;

Procedure TDelphiParser._IdentTypes;
  BEGIN
    _Ident;
    IF (sym = 17) THEN BEGIN
      PerformGet;
      IF _In(symSet[5], sym) THEN BEGIN
        _ConstExpr;
        WHILE _In(symSet[9], sym) DO BEGIN
          IF (sym = 52) OR (sym = 54) OR (sym = 55) OR (sym = 70) THEN BEGIN
            _AddOp;
          END ELSE IF _In(symSet[14], sym) THEN BEGIN
            _MulOp;
          END ELSE IF (sym = 52) THEN BEGIN
            PerformGet;
          END ELSE BEGIN
            PerformGet;
          END;
          _ConstExpr;
        END;
      END ELSE IF _In(symSet[11], sym) THEN BEGIN
        _Type;
      END ELSE BEGIN SynError(144);
      END;
      Expect(18);
    END;
    IF (sym = 12) OR (sym = 25) THEN BEGIN
      IF (sym = 25) THEN BEGIN
        PerformGet;
        _Ident;
      END ELSE BEGIN
        PerformGet;
        IF _In(symSet[8], sym) THEN BEGIN
          _Ident;
          IF (sym = 17) THEN BEGIN
            PerformGet;
            IF _In(symSet[5], sym) THEN BEGIN
              _ConstExpr;
            END ELSE IF _In(symSet[11], sym) THEN BEGIN
              _Type;
            END ELSE BEGIN SynError(145);
            END;
            Expect(18);
          END;
        END ELSE IF (sym = 2) OR (sym = 4) THEN BEGIN
          _Number;
        END ELSE BEGIN SynError(146);
        END;
      END;
    END;
  END;

Procedure TDelphiParser._VariantType;
  BEGIN
    IF (sym = 65) THEN BEGIN
      PerformGet;
    END ELSE IF (sym = 66) THEN BEGIN
      PerformGet;
    END ELSE BEGIN SynError(147);
    END;
  END;

Procedure TDelphiParser._ProcedureType;
  BEGIN
    IF (sym = 59) THEN BEGIN
      PerformGet;
      IF (sym = 17) THEN BEGIN
        _FormalParameters;
      END;
    END ELSE IF (sym = 61) THEN BEGIN
      PerformGet;
      IF (sym = 17) THEN BEGIN
        _FormalParameters;
      END;
      Expect(32);
      _Type;
    END ELSE BEGIN SynError(148);
    END;
    IF (sym = 39) THEN BEGIN
      PerformGet;
      Expect(49);
    END;
    IF (sym = 62) OR (sym = 63) THEN BEGIN
      IF (sym = 62) THEN BEGIN
        PerformGet;
      END ELSE BEGIN
        PerformGet;
      END;
    END;
  END;

Procedure TDelphiParser._StringType;
  BEGIN
    IF (sym = 67) THEN BEGIN
      PerformGet;
      IF (sym = 15) THEN BEGIN
        PerformGet;
        _ConstExpr;
        WHILE _In(symSet[9], sym) DO BEGIN
          IF (sym = 52) OR (sym = 54) OR (sym = 55) OR (sym = 70) THEN BEGIN
            _AddOp;
          END ELSE BEGIN
            _MulOp;
          END;
          _ConstExpr;
        END;
        Expect(16);
      END;
    END ELSE IF (sym = 68) THEN BEGIN
      PerformGet;
    END ELSE IF (sym = 69) THEN BEGIN
      PerformGet;
    END ELSE BEGIN SynError(149);
    END;
  END;

Procedure TDelphiParser._RealType;
  BEGIN
    CASE sym OF
      90 : BEGIN
        PerformGet;
        END;
      91 : BEGIN
        PerformGet;
        END;
      92 : BEGIN
        PerformGet;
        END;
      93 : BEGIN
        PerformGet;
        END;
      94 : BEGIN
        PerformGet;
        END;
      95 : BEGIN
        PerformGet;
        END;
      96 : BEGIN
        PerformGet;
        END;
    ELSE BEGIN SynError(150);
        END;
    END;
  END;

Procedure TDelphiParser._OrdIdent;
  BEGIN
    CASE sym OF
      78 : BEGIN
        PerformGet;
        END;
      79 : BEGIN
        PerformGet;
        END;
      80 : BEGIN
        PerformGet;
        END;
      81 : BEGIN
        PerformGet;
        END;
      82 : BEGIN
        PerformGet;
        END;
      83 : BEGIN
        PerformGet;
        END;
      84 : BEGIN
        PerformGet;
        END;
      85 : BEGIN
        PerformGet;
        END;
      86 : BEGIN
        PerformGet;
        END;
      87 : BEGIN
        PerformGet;
        END;
      88 : BEGIN
        PerformGet;
        END;
      89 : BEGIN
        PerformGet;
        END;
    ELSE BEGIN SynError(151);
        END;
    END;
  END;

Procedure TDelphiParser._EnumeratedType;
  BEGIN
    Expect(17);
    _EnumeratedTypeElement;
    WHILE (sym = 31) OR (sym = 52) DO BEGIN
      IF (sym = 31) THEN BEGIN
        PerformGet;
      END ELSE BEGIN
        PerformGet;
      END;
      _EnumeratedTypeElement;
    END;
    Expect(18);
  END;

Procedure TDelphiParser._ObjField;
  BEGIN
    _IdentList;
    Expect(32);
    _Type;
    IF (sym = 48) THEN BEGIN
      PerformGet;
    END;
    Expect(8);
  END;

Procedure TDelphiParser._FormalParameters;
  BEGIN
    Expect(17);
    IF (sym = 18) THEN BEGIN
      PerformGet;
    END ELSE IF _In(symSet[15], sym) THEN BEGIN
      _FormalParm;
      WHILE (sym = 8) DO BEGIN
        PerformGet;
        _FormalParm;
      END;
      Expect(18);
    END ELSE BEGIN SynError(152);
    END;
  END;

Procedure TDelphiParser._PointerType;
  BEGIN
    Expect(45);
    _TypeId;
  END;

Procedure TDelphiParser._SubrangeType;
  BEGIN
    IF (sym = 52) OR (sym = 54) OR (sym = 55) OR (sym = 70) THEN BEGIN
      _AddOp;
    END;
    _ConstExpr;
    Expect(12);
    _ConstExpr;
    WHILE _In(symSet[9], sym) DO BEGIN
      IF _In(symSet[14], sym) THEN BEGIN
        _MulOp;
      END ELSE BEGIN
        _AddOp;
      END;
      _ConstExpr;
    END;
  END;

Procedure TDelphiParser._VarDecl;
  BEGIN
    WriteStr( 'VarDecl--------->' +#13#10) ;
    _IdentList;
    Expect(32);
    IF _In(symSet[11], sym) THEN BEGIN
      _Type;
    END ELSE IF (sym = 3) OR (sym = 118) THEN BEGIN
      _String;
    END ELSE BEGIN SynError(153);
    END;
    IF (sym = 11) OR (sym = 57) THEN BEGIN
      IF (sym = 57) THEN BEGIN
        PerformGet;
        _ConstExpr;
      END ELSE BEGIN
        PerformGet;
        IF (sym = 58) THEN BEGIN
          PerformGet;
        END;
        _TypedConstant;
      END;
    END;
    //WriteStr( 'END VarDecl---------<' +#13#10) ;
  END;

Procedure TDelphiParser._RecField;
  BEGIN
    IF _In(symSet[7], sym) THEN BEGIN
      _BadNames;
    END ELSE IF _In(symSet[2], sym) THEN BEGIN
      _IdentList;
    END ELSE BEGIN SynError(154);
    END;
    Expect(32);
    IF (sym = 17) THEN BEGIN
      PerformGet;
      _VarDecl;
      WHILE (sym = 8) DO BEGIN
        PerformGet;
        _VarDecl;
      END;
      Expect(18);
    END ELSE IF _In(symSet[11], sym) THEN BEGIN
      _Type;
    END ELSE BEGIN SynError(155);
    END;
  END;

Procedure TDelphiParser._CaseItem;
  BEGIN
    //WriteStr( 'REC CASE ITEM Start' +#13#10 ) ;
    Expect(2);
    WHILE (sym = 12) OR (sym = 31) DO BEGIN
      IF (sym = 31) THEN BEGIN
        PerformGet;
      END ELSE BEGIN
        PerformGet;
      END;
      Expect(2);
    END;
    Expect(32);
    Expect(17);
    IF _In(symSet[16], sym) THEN BEGIN
      _RecItem;
    END ELSE IF _In(symSet[2], sym) THEN BEGIN
      _VarDecl;
    END ELSE BEGIN SynError(156);
    END;
    WHILE (sym = 8) DO BEGIN
      PerformGet;
      IF _In(symSet[16], sym) THEN BEGIN
        _RecItem;
      END ELSE IF _In(symSet[2], sym) THEN BEGIN
        _VarDecl;
      END ELSE BEGIN SynError(157);
      END;
    END;
    Expect(18);
  END;

Procedure TDelphiParser._RecItem;
  BEGIN
    IF (sym = 2) THEN BEGIN
      //WriteStr( 'In RecItem' +#13#10 ) ;
      _CaseItem;
    END ELSE IF (sym = 42) THEN BEGIN
      PerformGet;
      //WriteStr( 'REC CASE Start' +#13#10 ) ;
      IF _In(symSet[11], sym) THEN BEGIN
        _TypeId;
      END ELSE IF _In(symSet[17], sym) THEN BEGIN
        IF _In(symSet[8], sym) THEN BEGIN
          _Ident;
        END ELSE BEGIN
          _BadNames;
        END;
        Expect(32);
        _TypeId;
      END ELSE BEGIN SynError(158);
      END;
      Expect(39);
      _RecItem;
    END ELSE IF _In(symSet[2], sym) THEN BEGIN
      //SetStart ;
      _RecField;
      //WriteStr( CopySourceToCurrent +#13#10) ;
    END ELSE BEGIN SynError(159);
    END;
  END;

Procedure TDelphiParser._MulOp;
  BEGIN
    CASE sym OF
      71 : BEGIN
        PerformGet;
        END;
      72 : BEGIN
        PerformGet;
        END;
      73 : BEGIN
        PerformGet;
        END;
      74 : BEGIN
        PerformGet;
        END;
      53 : BEGIN
        PerformGet;
        END;
      75 : BEGIN
        PerformGet;
        END;
      76 : BEGIN
        PerformGet;
        END;
    ELSE BEGIN SynError(160);
        END;
    END;
  END;

Procedure TDelphiParser._AddOp;
  BEGIN
    IF (sym = 54) THEN BEGIN
      PerformGet;
    END ELSE IF (sym = 55) THEN BEGIN
      PerformGet;
    END ELSE IF (sym = 52) THEN BEGIN
      PerformGet;
    END ELSE IF (sym = 70) THEN BEGIN
      PerformGet;
    END ELSE BEGIN SynError(161);
    END;
  END;

Procedure TDelphiParser._Number;
  BEGIN
    IF (sym = 2) THEN BEGIN
      PerformGet;
    END ELSE IF (sym = 4) THEN BEGIN
      PerformGet;
    END ELSE BEGIN SynError(162);
    END;
  END;

Procedure TDelphiParser._ConstantDeclBody;
  BEGIN
    //WriteStr( 'In ConstantDeclBody' +#13#10) ;
    IF (sym = 112) THEN BEGIN
      PerformGet;
    END;
    IF _In(symSet[18], sym) THEN BEGIN
      IF _In(symSet[19], sym) THEN BEGIN
        //WriteStr( 'In ->OrdIdent->' +#13#10) ;
        _OrdIdent;
      END;
      //WriteStr( 'Writing Bracket' +#13#10) ;
      Expect(17);
    END;
    //WriteStr( 'Entering ConstExpr ' +#13#10) ;
    IF _In(symSet[20], sym) THEN BEGIN
      //WriteStr( 'Entering ->GUIDDef ' +#13#10) ;
      _GUIDDef;
    END ELSE IF _In(symSet[11], sym) THEN BEGIN
      WriteStr( 'Entering ->Type' +#13#10) ;
      _Type;
    END ELSE IF (sym = 2) OR (sym = 4) OR (sym = 5) OR (sym = 54) OR (sym = 55) THEN BEGIN
      //WriteStr( 'Entering ->NumberList ' +#13#10) ;
      _NumberList;
    END ELSE IF _In(symSet[5], sym) THEN BEGIN
      //WriteStr( 'Entering ->ConstExpr  ' +#13#10) ;
      _ConstExpr;
    END ELSE BEGIN SynError(163);
    END;
    WHILE _In(symSet[9], sym) DO BEGIN
      IF (sym = 52) OR (sym = 54) OR (sym = 55) OR (sym = 70) THEN BEGIN
        _AddOp;
      END ELSE BEGIN
        _MulOp;
      END;
      _ConstExpr;
    END;
    IF (sym = 18) THEN BEGIN
      PerformGet;
      WHILE _In(symSet[9], sym) DO BEGIN
        IF (sym = 52) OR (sym = 54) OR (sym = 55) OR (sym = 70) THEN BEGIN
          _AddOp;
        END ELSE BEGIN
          _MulOp;
        END;
        _ConstExpr;
      END;
    END;
  END;

Procedure TDelphiParser._RecType;
  BEGIN
    Expect(41);
    // WriteStr( 'RECORD ->' +#13#10) ;
    IF _In(symSet[16], sym) THEN BEGIN
      _RecItem;
      WHILE (sym = 8) DO BEGIN
        PerformGet;
        IF _In(symSet[16], sym) THEN BEGIN
          _RecItem;
        END ELSE IF (sym = 8) OR (sym = 14) THEN BEGIN
        END ELSE BEGIN SynError(164);
        END;
      END;
    END;
    Expect(14);
    //WriteStr( 'End RECORD' +#13#10) ;
  END;

Procedure TDelphiParser._FileType;
  BEGIN
    Expect(44);
    IF (sym = 39) THEN BEGIN
      PerformGet;
      _TypeId;
    END;
  END;

Procedure TDelphiParser._SetType;
  BEGIN
    //WriteStr( 'Set Type ->' +#13#10) ;
    Expect(43);
    Expect(39);
    IF _In(symSet[11], sym) THEN BEGIN
      _Type;
    END ELSE IF _In(symSet[21], sym) THEN BEGIN
      _SubrangeType;
    END ELSE BEGIN SynError(165);
    END;
  END;

Procedure TDelphiParser._ArrayType;
  BEGIN
    WriteStr( 'In ArrayType ->' +#13#10) ;
    Expect(38);
    IF (sym = 15) THEN BEGIN
      PerformGet;
      IF _In(symSet[11], sym) THEN BEGIN
        _Type;
      END ELSE IF _In(symSet[22], sym) THEN BEGIN
        IF _In(symSet[22], sym) THEN BEGIN
          _ConstantDeclBody;
        END ELSE BEGIN
          _Number;
        END;
        IF (sym = 12) THEN BEGIN
          WriteStr( 'In .. section ->' +#13#10) ;
          PerformGet;
          IF _In(symSet[23], sym) THEN BEGIN
            _ConstantDeclBody;
          END ELSE IF (sym = 2) OR (sym = 4) THEN BEGIN
            _Number;
          END ELSE IF (sym = 6) THEN BEGIN
            PerformGet;
          END ELSE BEGIN SynError(166);
          END;
          WHILE _In(symSet[9], sym) DO BEGIN
            WriteStr( 'In extended section ->' +#13#10) ;
            IF (sym = 52) OR (sym = 54) OR (sym = 55) OR (sym = 70) THEN BEGIN
              _AddOp;
            END ELSE BEGIN
              _MulOp;
            END;
            IF _In(symSet[8], sym) THEN BEGIN
              _Ident;
            END ELSE IF (sym = 2) OR (sym = 4) THEN BEGIN
              _Number;
            END ELSE BEGIN SynError(167);
            END;
          END;
        END;
      END ELSE BEGIN SynError(168);
      END;
      Expect(16);
    END;
    Expect(39);
    IF (sym = 40) THEN BEGIN
      PerformGet;
    END ELSE IF _In(symSet[11], sym) THEN BEGIN
      _Type;
    END ELSE BEGIN SynError(169);
    END;
  END;

Procedure TDelphiParser._StrucType;
  BEGIN
    IF (sym = 37) THEN BEGIN
      PerformGet;
    END;
    IF (sym = 38) THEN BEGIN
      _ArrayType;
    END ELSE IF (sym = 43) THEN BEGIN
      _SetType;
    END ELSE IF (sym = 44) THEN BEGIN
      _FileType;
    END ELSE IF (sym = 41) THEN BEGIN
      _RecType;
    END ELSE BEGIN SynError(170);
    END;
  END;

Procedure TDelphiParser._DestructorHeading;
  BEGIN
    Expect(47);
    _Ident;
    IF (sym = 17) THEN BEGIN
      _FormalParameters;
    END;
  END;

Procedure TDelphiParser._ConstructorHeading;
  BEGIN
    Expect(46);
    _Ident;
    IF (sym = 17) THEN BEGIN
      _FormalParameters;
    END;
  END;

Procedure TDelphiParser._FunctionHeading;
  BEGIN
    Expect(61);
    _Ident;
    IF (sym = 25) THEN BEGIN
      PerformGet;
      _Ident;
    END;
    //WriteStr( 'FUNCTION ->' +GetLexString+#13#10) ;
    IF (sym = 17) OR (sym = 32) THEN BEGIN
      IF (sym = 17) THEN BEGIN
        _FormalParameters;
      END;
      Expect(32);
      _Type;
      IF (sym = 62) OR (sym = 63) THEN BEGIN
        IF (sym = 62) THEN BEGIN
          PerformGet;
        END ELSE BEGIN
          PerformGet;
        END;
      END;
    END ELSE IF (sym = 11) THEN BEGIN
      PerformGet;
      _Ident;
    END ELSE BEGIN SynError(171);
    END;
  END;

Procedure TDelphiParser._ProcedureHeading;
  BEGIN
    Expect(59);
    IF _In(symSet[8], sym) THEN BEGIN
      _Ident;
      IF (sym = 25) THEN BEGIN
        PerformGet;
        _Ident;
      END;
      //WriteStr( 'PROCEDURE ->' +GetLexString+#13#10) ;
      IF _In(symSet[24], sym) THEN BEGIN
        IF (sym = 17) THEN BEGIN
          _FormalParameters;
        END;
      END ELSE IF (sym = 11) THEN BEGIN
        PerformGet;
        _Ident;
      END ELSE BEGIN SynError(172);
      END;
    END ELSE IF (sym = 60) THEN BEGIN
      PerformGet;
    END ELSE BEGIN SynError(173);
    END;
  END;

Procedure TDelphiParser._MethodHeading;
  BEGIN
    IF (sym = 59) THEN BEGIN
      _ProcedureHeading;
    END ELSE IF (sym = 61) THEN BEGIN
      _FunctionHeading;
    END ELSE IF (sym = 46) THEN BEGIN
      _ConstructorHeading;
    END ELSE IF (sym = 47) THEN BEGIN
      _DestructorHeading;
    END ELSE BEGIN SynError(174);
    END;
  END;

Procedure TDelphiParser._Method;
  BEGIN
    IF (sym = 35) THEN BEGIN
      PerformGet;
    END;
    _MethodHeading;
    IF (sym = 8) THEN BEGIN
      PerformGet;
    END;
    WHILE _In(symSet[1], sym) DO BEGIN
      _Directive;
      IF _In(symSet[8], sym) THEN BEGIN
        _Ident;
      END;
      Expect(8);
    END;
    IF (sym = 36) THEN BEGIN
      PerformGet;
      Expect(8);
    END;
  END;

Procedure TDelphiParser._AccessSettings;
  BEGIN
    IF (sym = 109) THEN BEGIN
      PerformGet;
    END ELSE IF (sym = 110) THEN BEGIN
      PerformGet;
    END ELSE BEGIN SynError(175);
    END;
  END;

Procedure TDelphiParser._Property;
  BEGIN
    Expect(33);
    PerformGet;
    //WriteStr( 'PROPERTY' +GetLexString+ ' ->' +#13#10) ;
    IF (sym = 15) OR (sym = 32) THEN BEGIN
      _PropertyInterface;
    END;
    _PropertySpecifiers;
    IF (sym = 109) OR (sym = 110) THEN BEGIN
      _AccessSettings;
    END;
    IF (sym = 34) THEN BEGIN
      PerformGet;
      IF (sym = 2) OR (sym = 4) OR (sym = 5) OR (sym = 54) OR (sym = 55) THEN BEGIN
        _NumberTypes;
      END ELSE IF _In(symSet[8], sym) THEN BEGIN
        _Ident;
      END ELSE BEGIN SynError(176);
      END;
    END;
  END;

Procedure TDelphiParser._PropertyList;
  BEGIN
    _Property;
    Expect(8);
    IF (sym = 28) THEN BEGIN
      PerformGet;
      Expect(8);
    END;
    WHILE (sym = 33) DO BEGIN
      _Property;
      Expect(8);
      IF (sym = 28) THEN BEGIN
        PerformGet;
        Expect(8);
      END;
    END;
  END;

Procedure TDelphiParser._Type;
  BEGIN
    IF (sym = 50) THEN BEGIN
      PerformGet;
      Expect(25);
    END;
    CASE sym OF
      17 : BEGIN
        WriteStr( ' EnumeratedType ' +#13#10 ) ;
        _EnumeratedType;
        END;
      78, 79, 80, 81, 82, 83, 84, 85, 86, 87, 88, 89 : BEGIN
        WriteStr( ' OrdIdent ' +#13#10 ) ;
        _OrdIdent;
        END;
      90, 91, 92, 93, 94, 95, 96 : BEGIN
        WriteStr( ' RealType ' +#13#10 ) ;
        _RealType;
        END;
      37, 38, 41, 43, 44 : BEGIN
        WriteStr( '  StrucType  ' +#13#10 ) ;
        _StrucType;
        END;
      45 : BEGIN
        WriteStr( '   PointerType ' +#13#10 ) ;
        _PointerType;
        END;
      67, 68, 69 : BEGIN
        WriteStr( '   StringType  ' +#13#10 ) ;
        _StringType;
        END;
      59, 61 : BEGIN
        WriteStr( '   ProcedureType   ' +#13#10 ) ;
        _ProcedureType;
        END;
      65, 66 : BEGIN
        WriteStr( '    VariantType  ' +#13#10 ) ;
        _VariantType;
        END;
      1, 23, 24, 26, 28, 34, 48, 51, 60, 62, 63, 97, 98, 99, 100, 101, 102, 103, 104, 105, 106, 107, 108, 109, 110 : BEGIN
        WriteStr( '  IdentTypes ' +#13#10 ) ;
        _IdentTypes;
        END;
      2, 4, 5, 54, 55 : BEGIN
        WriteStr( '  NumberTypes ' +#13#10 ) ;
        _NumberTypes;
        END;
    ELSE BEGIN SynError(177);
        END;
    END;
    IF (sym = 48) OR (sym = 51) THEN BEGIN
      IF (sym = 48) THEN BEGIN
        PerformGet;
      END ELSE BEGIN
        PerformGet;
      END;
    END;
  END;

Procedure TDelphiParser._PropertyInterface;
  BEGIN
    IF (sym = 15) THEN BEGIN
      _PropertyParameterList;
    END;
    Expect(32);
    _Type;
  END;

Procedure TDelphiParser._FormalParm;
  BEGIN
    IF (sym = 40) OR (sym = 56) OR (sym = 64) THEN BEGIN
      IF (sym = 56) THEN BEGIN
        PerformGet;
      END ELSE IF (sym = 40) THEN BEGIN
        PerformGet;
      END ELSE BEGIN
        PerformGet;
      END;
    END;
    _Parameter;
  END;

Procedure TDelphiParser._PropertyParameterList;
  BEGIN
    Expect(15);
    _FormalParm;
    WHILE (sym = 8) DO BEGIN
      PerformGet;
      _FormalParm;
    END;
    Expect(16);
  END;

Procedure TDelphiParser._ObjHeritage;
  BEGIN
    Expect(17);
    _TypeId;
    Expect(18);
  END;

Procedure TDelphiParser._PropertySpecifiers;
  BEGIN
    IF (sym = 23) THEN BEGIN
      PerformGet;
      _ConstExpr;
    END;
    IF (sym = 24) THEN BEGIN
      PerformGet;
      _Ident;
      IF (sym = 25) THEN BEGIN
        PerformGet;
        _Ident;
      END;
    END;
    IF (sym = 26) THEN BEGIN
      PerformGet;
      _Ident;
      IF (sym = 25) THEN BEGIN
        PerformGet;
        _Ident;
      END;
    END;
    IF (sym = 27) THEN BEGIN
      PerformGet;
      IF _In(symSet[8], sym) THEN BEGIN
        _Ident;
      END ELSE IF (sym = 2) OR (sym = 4) OR (sym = 5) OR (sym = 54) OR (sym = 55) THEN BEGIN
        _NumberTypes;
      END ELSE BEGIN SynError(178);
      END;
    END;
    IF (sym = 28) OR (sym = 29) THEN BEGIN
      IF (sym = 28) THEN BEGIN
        PerformGet;
        IF _In(symSet[5], sym) THEN BEGIN
          IF (sym = 2) OR (sym = 4) OR (sym = 5) OR (sym = 54) OR (sym = 55) THEN BEGIN
            _NumberTypes;
          END ELSE BEGIN
            _ConstExpr;
          END;
        END;
      END ELSE BEGIN
        PerformGet;
      END;
    END;
    IF (sym = 30) THEN BEGIN
      PerformGet;
      _TypeId;
      WHILE (sym = 31) DO BEGIN
        PerformGet;
        _TypeId;
      END;
    END;
  END;

Procedure TDelphiParser._ObjFieldList;
  BEGIN
    //SetStart ;
    _ObjField;
    WHILE _In(symSet[2], sym) DO BEGIN
      _ObjField;
    END;
    //WriteStr( 'ObjFieldList  ' +CopySourceToCurrent+ ' ->' +#13#10) ;
  END;

Procedure TDelphiParser._MethodList;
  BEGIN
    _Method;
    WHILE (sym = 35) OR (sym = 46) OR (sym = 47) OR (sym = 59) OR (sym = 61) DO BEGIN
      _Method;
    END;
  END;

Procedure TDelphiParser._ClassFieldList;
  BEGIN
    _ObjFieldList;
  END;

Procedure TDelphiParser._ClassHeritage;
  BEGIN
    Expect(17);
    SetStart ;
    _IdentList;
    //WriteStr( 'Inherits from ' +CopySourceToCurrent+#13#10) ;
    Expect(18);
  END;

Procedure TDelphiParser._ClassTypeBody;
  BEGIN
    IF (sym = 17) THEN BEGIN
      _ClassHeritage;
    END;
    IF _In(symSet[25], sym) THEN BEGIN
      IF _In(symSet[2], sym) THEN BEGIN
        //WriteStr( 'Private Form Fields ->' +#13#10) ;
        _ClassFieldList;
      END;
      IF (sym = 35) OR (sym = 46) OR (sym = 47) OR (sym = 59) OR (sym = 61) THEN BEGIN
        //WriteStr( 'Private Form Methods ->' +#13#10) ;
        _ClassMethodList;
      END;
      IF (sym = 33) THEN BEGIN
        //WriteStr( 'Private Form Properties ->' +#13#10) ;
        _ClassPropertyList;
      END;
      WHILE (sym = 19) OR (sym = 20) OR (sym = 21) OR (sym = 22) DO BEGIN
        IF (sym = 19) THEN BEGIN
          PerformGet;
        END ELSE IF (sym = 20) THEN BEGIN
          PerformGet;
        END ELSE IF (sym = 21) THEN BEGIN
          PerformGet;
        END ELSE BEGIN
          PerformGet;
        END;
        //WriteStr( 'In ClassVisibility ' +GetLexString+#13#10) ;
        WHILE _In(symSet[26], sym) DO BEGIN
          IF _In(symSet[2], sym) THEN BEGIN
            //WriteStr( 'Fields ->' +#13#10) ;
            _ClassFieldList;
          END ELSE IF (sym = 35) OR (sym = 46) OR (sym = 47) OR (sym = 59) OR (sym = 61) THEN BEGIN
            //WriteStr( 'Methods ->' +#13#10) ;
            _ClassMethodList;
          END ELSE BEGIN
            //WriteStr( 'Properties ->' +#13#10) ;
            _ClassPropertyList;
          END;
        END;
      END;
      Expect(14);
    END;
    //WriteStr( 'End of Class Decl' +#13#10 ) ;
  END;

Procedure TDelphiParser._IdentList;
  BEGIN
    IF _In(symSet[7], sym) THEN BEGIN
      _BadNames;
    END ELSE IF _In(symSet[8], sym) THEN BEGIN
      _Ident;
    END ELSE IF (sym = 6) THEN BEGIN
      PerformGet;
    END ELSE BEGIN SynError(179);
    END;
    WHILE (sym = 31) OR (sym = 52) DO BEGIN
      IF (sym = 31) THEN BEGIN
        PerformGet;
      END ELSE BEGIN
        PerformGet;
      END;
      IF _In(symSet[7], sym) THEN BEGIN
        _BadNames;
      END ELSE IF _In(symSet[8], sym) THEN BEGIN
        _Ident;
      END ELSE IF (sym = 6) THEN BEGIN
        PerformGet;
      END ELSE BEGIN SynError(180);
      END;
    END;
  END;

Procedure TDelphiParser._ClassPropertyList;
  BEGIN
    _PropertyList;
  END;

Procedure TDelphiParser._ClassMethodList;
  BEGIN
    _MethodList;
  END;

Procedure TDelphiParser._GUID;
  BEGIN
    Expect(15);
    Expect(3);
    Expect(16);
  END;

Procedure TDelphiParser._InterfaceHeritage;
  BEGIN
    Expect(17);
    _IdentList;
    Expect(18);
  END;

Procedure TDelphiParser._InterfaceType;
  BEGIN
    IF (sym = 9) THEN BEGIN
      PerformGet;
    END ELSE IF (sym = 13) THEN BEGIN
      PerformGet;
    END ELSE BEGIN SynError(181);
    END;
    IF _In(symSet[27], sym) THEN BEGIN
      IF (sym = 17) THEN BEGIN
        _InterfaceHeritage;
      END;
      IF (sym = 15) THEN BEGIN
        _GUID;
      END;
      WHILE _In(symSet[28], sym) DO BEGIN
        IF (sym = 35) OR (sym = 46) OR (sym = 47) OR (sym = 59) OR (sym = 61) THEN BEGIN
          _ClassMethodList;
        END ELSE BEGIN
          _ClassPropertyList;
        END;
      END;
      Expect(14);
    END;
  END;

Procedure TDelphiParser._ObjectType;
  BEGIN
    Expect(49);
    IF (sym = 17) THEN BEGIN
      _ObjHeritage;
    END;
    IF _In(symSet[2], sym) THEN BEGIN
      _ObjFieldList;
    END;
    IF (sym = 35) OR (sym = 46) OR (sym = 47) OR (sym = 59) OR (sym = 61) THEN BEGIN
      _MethodList;
    END;
    Expect(14);
  END;

Procedure TDelphiParser._ConstExpr;
  BEGIN
    CASE sym OF
      77, 80, 81, 82, 111, 115, 116 : BEGIN
        WriteStr( 'In ConstExpr  ->' +#13#10) ;
        CASE sym OF
          77 : BEGIN
            PerformGet;
            END;
          81 : BEGIN
            PerformGet;
            END;
          111 : BEGIN
            PerformGet;
            END;
          82 : BEGIN
            PerformGet;
            END;
          80 : BEGIN
            PerformGet;
            END;
          115 : BEGIN
            PerformGet;
            END;
          116 : BEGIN
            PerformGet;
            END;
        END;
        Expect(17);
        IF _In(symSet[11], sym) THEN BEGIN
          _Type;
        END ELSE IF (sym = 3) OR (sym = 118) THEN BEGIN
          _String;
        END ELSE IF _In(symSet[5], sym) THEN BEGIN
          _ConstExpr;
        END ELSE BEGIN SynError(182);
        END;
        Expect(18);
        WHILE _In(symSet[29], sym) DO BEGIN
          IF _In(symSet[9], sym) THEN BEGIN
            IF (sym = 52) OR (sym = 54) OR (sym = 55) OR (sym = 70) THEN BEGIN
              _AddOp;
            END ELSE IF _In(symSet[14], sym) THEN BEGIN
              _MulOp;
            END ELSE BEGIN SynError(183);
            END;
            _ConstExpr;
          END ELSE BEGIN
            _NumberList;
          END;
        END;
        END;
      1, 2, 4, 5, 23, 24, 26, 28, 34, 48, 51, 54, 55, 58, 60, 62, 63, 97, 98, 99, 100, 101, 102, 103, 104, 105, 106, 107, 108, 109, 110, 112 : BEGIN
        IF (sym = 112) THEN BEGIN
          PerformGet;
        END;
        IF _In(symSet[30], sym) THEN BEGIN
          IF (sym = 58) THEN BEGIN
            PerformGet;
          END;
          _Ident;
          IF (sym = 17) THEN BEGIN
            PerformGet;
            IF _In(symSet[5], sym) THEN BEGIN
              WriteStr( 'Here  ->' +#13#10) ;
              _ConstExpr;
              WHILE _In(symSet[29], sym) DO BEGIN
                IF _In(symSet[9], sym) THEN BEGIN
                  IF (sym = 52) OR (sym = 54) OR (sym = 55) OR (sym = 70) THEN BEGIN
                    _AddOp;
                  END ELSE IF _In(symSet[14], sym) THEN BEGIN
                    _MulOp;
                  END ELSE BEGIN SynError(184);
                  END;
                  _ConstExpr;
                END ELSE BEGIN
                  _NumberList;
                END;
              END;
            END ELSE IF _In(symSet[11], sym) THEN BEGIN
              _Type;
            END ELSE BEGIN SynError(185);
            END;
            Expect(18);
          END;
        END ELSE IF (sym = 2) OR (sym = 4) OR (sym = 5) OR (sym = 54) OR (sym = 55) THEN BEGIN
          _NumberTypes;
        END ELSE BEGIN SynError(186);
        END;
        END;
      3, 118 : BEGIN
        _String;
        IF (sym = 12) THEN BEGIN
          PerformGet;
          _String;
        END;
        WHILE (sym = 31) DO BEGIN
          PerformGet;
          _String;
          IF (sym = 12) THEN BEGIN
            PerformGet;
            _String;
          END;
        END;
        END;
      15 : BEGIN
        PerformGet;
        IF _In(symSet[2], sym) THEN BEGIN
          WriteStr( 'IdentList  Here  ->' +#13#10) ;
          _IdentList;
          IF (sym = 12) THEN BEGIN
            PerformGet;
            _ConstExpr;
          END;
        END;
        Expect(16);
        END;
      6 : BEGIN
        PerformGet;
        IF (sym = 6) THEN BEGIN
          PerformGet;
        END;
        IF (sym = 12) THEN BEGIN
          PerformGet;
          _ConstExpr;
        END;
        END;
      17 : BEGIN
        PerformGet;
        IF _In(symSet[5], sym) THEN BEGIN
          _ConstExpr;
          WHILE _In(symSet[9], sym) DO BEGIN
            IF (sym = 52) OR (sym = 54) OR (sym = 55) OR (sym = 70) THEN BEGIN
              _AddOp;
            END ELSE BEGIN
              _MulOp;
            END;
            _ConstExpr;
          END;
        END ELSE IF (sym = 2) OR (sym = 4) OR (sym = 5) OR (sym = 54) OR (sym = 55) THEN BEGIN
          _NumberList;
        END ELSE IF (sym = 18) OR (sym = 32) OR (sym = 121) OR (sym = 124) THEN BEGIN
          _GUIDDef;
        END ELSE BEGIN SynError(187);
        END;
        IF (sym = 32) THEN BEGIN
          PerformGet;
          _ConstExpr;
        END;
        Expect(18);
        END;
    ELSE BEGIN SynError(188);
        END;
    END;
  END;

Procedure TDelphiParser._NumberTypes;
  BEGIN
    IF (sym = 54) OR (sym = 55) THEN BEGIN
      IF (sym = 54) THEN BEGIN
        PerformGet;
      END ELSE BEGIN
        PerformGet;
      END;
    END;
    IF (sym = 5) OR (sym = 54) OR (sym = 55) THEN BEGIN
      _HexNumber;
      IF _In(symSet[9], sym) THEN BEGIN
        IF (sym = 52) OR (sym = 54) OR (sym = 55) OR (sym = 70) THEN BEGIN
          _AddOp;
        END ELSE BEGIN
          _MulOp;
        END;
        _ConstExpr;
      END;
      IF (sym = 12) THEN BEGIN
        PerformGet;
        _ConstExpr;
        IF _In(symSet[9], sym) THEN BEGIN
          IF (sym = 52) OR (sym = 54) OR (sym = 55) OR (sym = 70) THEN BEGIN
            _AddOp;
          END ELSE BEGIN
            _MulOp;
          END;
          _ConstExpr;
        END;
      END;
    END ELSE IF (sym = 2) OR (sym = 4) THEN BEGIN
      _Number;
      IF (sym = 12) THEN BEGIN
        PerformGet;
        WriteStr( 'Entering NumberTypes ConstExpr' +#13#10) ;
        _ConstExpr;
        WHILE _In(symSet[9], sym) DO BEGIN
          IF (sym = 52) OR (sym = 54) OR (sym = 55) OR (sym = 70) THEN BEGIN
            _AddOp;
          END ELSE BEGIN
            _MulOp;
          END;
          _ConstExpr;
        END;
      END;
    END ELSE BEGIN SynError(189);
    END;
    //WriteStr( 'Leaving NUmberTypes' +#13#10) ;
  END;

Procedure TDelphiParser._ClassTypeGroup;
  BEGIN
    Expect(35);
    IF (sym = 39) THEN BEGIN
      _ClassRefBody;
    END ELSE IF _In(symSet[31], sym) THEN BEGIN
      _ClassTypeBody;
    END ELSE BEGIN SynError(190);
    END;
  END;

Procedure TDelphiParser._RestrictedType;
  BEGIN
    IF (sym = 49) THEN BEGIN
      _ObjectType;
    END ELSE IF (sym = 9) OR (sym = 13) THEN BEGIN
      _InterfaceType;
    END ELSE BEGIN SynError(191);
    END;
  END;

Procedure TDelphiParser._TypeId;
  BEGIN
    IF _In(symSet[11], sym) THEN BEGIN
      _Type;
    END ELSE IF _In(symSet[8], sym) THEN BEGIN
      _UnitId;
      Expect(25);
      _Type;
    END ELSE BEGIN SynError(192);
    END;
  END;

Procedure TDelphiParser._TypeDecl;
  //var S : String ;
  BEGIN
    IF _In(symSet[8], sym) THEN BEGIN
      _Ident;
    END ELSE IF _In(symSet[7], sym) THEN BEGIN
      _BadNames;
    END ELSE BEGIN SynError(193);
    END;
    //S := GetLexString ;
     // WriteStr( 'TypeName =' +S+#13#10) ;
    Expect(11);
    IF (sym = 10) THEN BEGIN
      PerformGet;
    END;
    IF _In(symSet[11], sym) THEN BEGIN
      WriteStr( 'Entering TypeId ' +#13#10) ;
      _TypeId;
    END ELSE IF (sym = 9) OR (sym = 13) OR (sym = 49) THEN BEGIN
      _RestrictedType;
    END ELSE IF (sym = 35) THEN BEGIN
      _ClassTypeGroup;
    END ELSE IF (sym = 2) OR (sym = 4) OR (sym = 5) OR (sym = 54) OR (sym = 55) THEN BEGIN
      _NumberTypes;
    END ELSE IF _In(symSet[5], sym) THEN BEGIN
      //WriteStr( 'In Const Expr Hunt ' ) ;
      _ConstExpr;
      IF (sym = 12) THEN BEGIN
        PerformGet;
        _ConstExpr;
      END;
    END ELSE BEGIN SynError(194);
    END;
    //WriteStr( 'End of Type =' +S+#13#10) ;
  END;

Procedure TDelphiParser._ResourceString;
  BEGIN
    Expect(117);
    WHILE _In(symSet[8], sym) DO BEGIN
      _Ident;
      Expect(11);
      _String;
      IF (sym = 51) THEN BEGIN
        PerformGet;
      END;
      Expect(8);
    END;
  END;

Procedure TDelphiParser._ExportedHeading;
  BEGIN
    IF (sym = 59) THEN BEGIN
      _ProcedureHeading;
    END ELSE IF (sym = 61) THEN BEGIN
      _FunctionHeading;
    END ELSE BEGIN SynError(195);
    END;
    Expect(8);
    WHILE _In(symSet[1], sym) DO BEGIN
      _Directive;
      Expect(8);
    END;
  END;

Procedure TDelphiParser._VarSection;
  BEGIN
    Expect(56);
    WHILE _In(symSet[2], sym) DO BEGIN
      _VarDecl;
      IF _In(symSet[1], sym) THEN BEGIN
        _Directive;
      END;
      Expect(8);
      IF _In(symSet[1], sym) THEN BEGIN
        _Directive;
        Expect(8);
      END;
    END;
  END;

Procedure TDelphiParser._TypeSection;
  BEGIN
    Expect(10);
    WHILE _In(symSet[17], sym) DO BEGIN
      //WriteStr( 'New TypeDecl ->' +#13#10) ;
      _TypeDecl;
      //WriteStr( 'Closing Semi-Coloon ->' +#13#10) ;
      Expect(8);
      WHILE _In(symSet[1], sym) DO BEGIN
        _Directive;
        Expect(8);
      END;
    END;
  END;

Procedure TDelphiParser._ConstSection;
  BEGIN
    Expect(40);
    //WriteStr( 'In "CONST" ' +#13#10) ;
    _ConstantDecl;
    Expect(8);
    WHILE _In(symSet[17], sym) DO BEGIN
      _ConstantDecl;
      Expect(8);
    END;
  END;

Procedure TDelphiParser._InterfaceDecl;
  BEGIN
    IF (sym = 40) THEN BEGIN
      //WriteStr( 'ConstSection ->' +#13#10) ;
      _ConstSection;
    END ELSE IF (sym = 10) THEN BEGIN
      //WriteStr( 'TypeSection ->' +#13#10) ;
      _TypeSection;
    END ELSE IF (sym = 56) THEN BEGIN
      //WriteStr( 'VarSection  ->' +#13#10) ;
      _VarSection;
    END ELSE IF (sym = 59) OR (sym = 61) THEN BEGIN
      _ExportedHeading;
    END ELSE IF (sym = 117) THEN BEGIN
      _ResourceString;
    END ELSE BEGIN SynError(196);
    END;
  END;

Procedure TDelphiParser._UsesClause;
  BEGIN
    Expect(114);
    _IdentList;
    Expect(8);
  END;

Procedure TDelphiParser._ImplementationSection;
  BEGIN
    Expect(113);
    WHILE _In(symSet[32], sym) DO BEGIN
      PerformGet;
    END;
  END;

Procedure TDelphiParser._InterfaceSection;
  BEGIN
    Expect(9);
    IF (sym = 114) THEN BEGIN
      _UsesClause;
    END;
    WHILE _In(symSet[33], sym) DO BEGIN
      _InterfaceDecl;
    END;
  END;

Procedure TDelphiParser._Directive;
  BEGIN
    CASE sym OF
      63 : BEGIN
        PerformGet;
        END;
      60 : BEGIN
        PerformGet;
        END;
      97 : BEGIN
        PerformGet;
        END;
      98 : BEGIN
        PerformGet;
        END;
      99 : BEGIN
        PerformGet;
        END;
      100 : BEGIN
        PerformGet;
        END;
      101 : BEGIN
        PerformGet;
        END;
      102 : BEGIN
        PerformGet;
        END;
      103 : BEGIN
        PerformGet;
        END;
      104 : BEGIN
        PerformGet;
        END;
      105 : BEGIN
        PerformGet;
        END;
      106 : BEGIN
        PerformGet;
        END;
      51 : BEGIN
        PerformGet;
        END;
      48 : BEGIN
        PerformGet;
        END;
      107 : BEGIN
        PerformGet;
        END;
      108 : BEGIN
        PerformGet;
        END;
      62 : BEGIN
        PerformGet;
        END;
      34, 109, 110 : BEGIN
        IF (sym = 109) OR (sym = 110) THEN BEGIN
          IF (sym = 109) THEN BEGIN
            PerformGet;
          END ELSE BEGIN
            PerformGet;
          END;
        END;
        Expect(34);
        _NumberTypes;
        END;
    ELSE BEGIN SynError(197);
        END;
    END;
  END;

Procedure TDelphiParser._BadNames;
  BEGIN
    CASE sym OF
      34 : BEGIN
        //WriteStr( 'BadNames' +#13#10) ;
        PerformGet;
        END;
      119 : BEGIN
        PerformGet;
        END;
      120 : BEGIN
        PerformGet;
        END;
      121 : BEGIN
        PerformGet;
        END;
      122 : BEGIN
        PerformGet;
        END;
      123 : BEGIN
        PerformGet;
        END;
      89 : BEGIN
        PerformGet;
        END;
      109 : BEGIN
        PerformGet;
        END;
      57 : BEGIN
        PerformGet;
        END;
      124 : BEGIN
        PerformGet;
        END;
      125 : BEGIN
        PerformGet;
        END;
      126 : BEGIN
        PerformGet;
        END;
      127 : BEGIN
        PerformGet;
        END;
      65 : BEGIN
        PerformGet;
        END;
      50 : BEGIN
        PerformGet;
        END;
    ELSE BEGIN SynError(198);
        END;
    END;
  END;

Procedure TDelphiParser._Ident;
  BEGIN
    IF (sym = 1) THEN BEGIN
      PerformGet;
    END ELSE IF _In(symSet[34], sym) THEN BEGIN
      _ReusableWords;
    END ELSE BEGIN SynError(199);
    END;
  END;

Procedure TDelphiParser._Unit;
  BEGIN
    Expect(7);
    IF _In(symSet[8], sym) THEN BEGIN
      _Ident;
    END ELSE IF _In(symSet[7], sym) THEN BEGIN
      _BadNames;
    END ELSE BEGIN SynError(200);
    END;
    IF _In(symSet[1], sym) THEN BEGIN
      _Directive;
    END;
    Expect(8);
    _InterfaceSection;
    _ImplementationSection;
  END;

Procedure TDelphiParser._SourceFile;
  BEGIN
    _Unit;
  END;

Procedure TDelphiParser._Delphi;
  BEGIN
    Init ;
    _SourceFile;
    //WriteStr(CopySourceToCurrent) ;
    Expect(0);
    Final ;
  END;



procedure TDelphiParser.Parse;
begin
  if (src.DataString = '') then 
    lst.WriteString('Empty Source')
    Else Begin    
   _Reset; PerformGet;
   _Delphi;

    End;
end;

destructor TDelphiParser.Destroy;
Begin
{PBDESTROY}
  fOutputStream.Free;

{ENDPBDESTROY}
  inherited;
End;

constructor TDelphiParser.Create;
begin
  inherited;
{PBCREATE}
  fOutputStream := TStringStream.Create('' );
 Error := ReportError;

{ENDPBCREATE}
  errDist := minErrDist;
   symSet[0, 0] := [0];
  symSet[0, 1] := [];
  symSet[0, 2] := [];
  symSet[0, 3] := [];
  symSet[0, 4] := [];
  symSet[0, 5] := [];
  symSet[0, 6] := [];
  symSet[0, 7] := [];
  symSet[0, 8] := [];
  symSet[1, 0] := [];
  symSet[1, 1] := [];
  symSet[1, 2] := [2];
  symSet[1, 3] := [0, 3, 12, 14, 15];
  symSet[1, 4] := [];
  symSet[1, 5] := [];
  symSet[1, 6] := [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14];
  symSet[1, 7] := [];
  symSet[1, 8] := [];
  symSet[2, 0] := [1, 6];
  symSet[2, 1] := [7, 8, 10, 12];
  symSet[2, 2] := [2];
  symSet[2, 3] := [0, 2, 3, 9, 12, 14, 15];
  symSet[2, 4] := [1];
  symSet[2, 5] := [9];
  symSet[2, 6] := [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14];
  symSet[2, 7] := [7, 8, 9, 10, 11, 12, 13, 14, 15];
  symSet[2, 8] := [];
  symSet[3, 0] := [1, 2, 3, 4, 5, 6, 8, 15];
  symSet[3, 1] := [2, 7, 8, 10, 12, 15];
  symSet[3, 2] := [0, 2];
  symSet[3, 3] := [0, 2, 3, 4, 5, 6, 7, 9, 12, 14, 15];
  symSet[3, 4] := [1, 6, 7, 8, 9, 10, 11, 12];
  symSet[3, 5] := [9];
  symSet[3, 6] := [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14];
  symSet[3, 7] := [6, 7, 8, 9, 10, 11, 12, 13, 14, 15];
  symSet[3, 8] := [];
  symSet[4, 0] := [8];
  symSet[4, 1] := [2, 15];
  symSet[4, 2] := [0, 2];
  symSet[4, 3] := [0, 3, 4, 5, 6, 7, 12, 14, 15];
  symSet[4, 4] := [6, 7, 8, 9, 10, 11, 12];
  symSet[4, 5] := [];
  symSet[4, 6] := [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14];
  symSet[4, 7] := [9, 12];
  symSet[4, 8] := [];
  symSet[5, 0] := [1, 2, 3, 4, 5, 6, 15];
  symSet[5, 1] := [1, 7, 8, 10, 12];
  symSet[5, 2] := [2];
  symSet[5, 3] := [0, 3, 6, 7, 10, 12, 14, 15];
  symSet[5, 4] := [13];
  symSet[5, 5] := [0, 1, 2];
  symSet[5, 6] := [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15];
  symSet[5, 7] := [0, 3, 4, 6];
  symSet[5, 8] := [];
  symSet[6, 0] := [8, 12];
  symSet[6, 1] := [0, 2, 15];
  symSet[6, 2] := [0, 2];
  symSet[6, 3] := [0, 3, 4, 5, 6, 7, 12, 14, 15];
  symSet[6, 4] := [6, 7, 8, 9, 10, 11, 12];
  symSet[6, 5] := [];
  symSet[6, 6] := [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14];
  symSet[6, 7] := [9];
  symSet[6, 8] := [];
  symSet[7, 0] := [];
  symSet[7, 1] := [];
  symSet[7, 2] := [2];
  symSet[7, 3] := [2, 9];
  symSet[7, 4] := [1];
  symSet[7, 5] := [9];
  symSet[7, 6] := [13];
  symSet[7, 7] := [7, 8, 9, 10, 11, 12, 13, 14, 15];
  symSet[7, 8] := [];
  symSet[8, 0] := [1];
  symSet[8, 1] := [7, 8, 10, 12];
  symSet[8, 2] := [2];
  symSet[8, 3] := [0, 3, 12, 14, 15];
  symSet[8, 4] := [];
  symSet[8, 5] := [];
  symSet[8, 6] := [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14];
  symSet[8, 7] := [];
  symSet[8, 8] := [];
  symSet[9, 0] := [];
  symSet[9, 1] := [];
  symSet[9, 2] := [];
  symSet[9, 3] := [4, 5, 6, 7];
  symSet[9, 4] := [6, 7, 8, 9, 10, 11, 12];
  symSet[9, 5] := [];
  symSet[9, 6] := [];
  symSet[9, 7] := [];
  symSet[9, 8] := [];
  symSet[10, 0] := [1, 2, 3, 4, 5, 6, 8, 15];
  symSet[10, 1] := [1, 7, 8, 10, 12];
  symSet[10, 2] := [0, 2];
  symSet[10, 3] := [0, 2, 3, 6, 7, 9, 12, 14, 15];
  symSet[10, 4] := [1];
  symSet[10, 5] := [9];
  symSet[10, 6] := [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14];
  symSet[10, 7] := [6, 7, 8, 9, 10, 11, 12, 13, 14, 15];
  symSet[10, 8] := [];
  symSet[11, 0] := [1, 2, 4, 5];
  symSet[11, 1] := [1, 7, 8, 10, 12];
  symSet[11, 2] := [2, 5, 6, 9, 11, 12, 13];
  symSet[11, 3] := [0, 2, 3, 6, 7, 11, 12, 13, 14, 15];
  symSet[11, 4] := [1, 2, 3, 4, 5, 14, 15];
  symSet[11, 5] := [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15];
  symSet[11, 6] := [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14];
  symSet[11, 7] := [];
  symSet[11, 8] := [];
  symSet[12, 0] := [8];
  symSet[12, 1] := [15];
  symSet[12, 2] := [];
  symSet[12, 3] := [4, 5, 6, 7];
  symSet[12, 4] := [6, 7, 8, 9, 10, 11, 12];
  symSet[12, 5] := [];
  symSet[12, 6] := [];
  symSet[12, 7] := [];
  symSet[12, 8] := [];
  symSet[13, 0] := [1, 2, 3, 4, 5, 6, 8, 15];
  symSet[13, 1] := [1, 2, 7, 8, 10, 12];
  symSet[13, 2] := [0, 2];
  symSet[13, 3] := [0, 2, 3, 6, 7, 9, 12, 14, 15];
  symSet[13, 4] := [1];
  symSet[13, 5] := [9];
  symSet[13, 6] := [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14];
  symSet[13, 7] := [6, 7, 8, 9, 10, 11, 12, 13, 14, 15];
  symSet[13, 8] := [];
  symSet[14, 0] := [];
  symSet[14, 1] := [];
  symSet[14, 2] := [];
  symSet[14, 3] := [5];
  symSet[14, 4] := [7, 8, 9, 10, 11, 12];
  symSet[14, 5] := [];
  symSet[14, 6] := [];
  symSet[14, 7] := [];
  symSet[14, 8] := [];
  symSet[15, 0] := [1, 6];
  symSet[15, 1] := [7, 8, 10, 12];
  symSet[15, 2] := [2, 8];
  symSet[15, 3] := [0, 2, 3, 8, 9, 12, 14, 15];
  symSet[15, 4] := [0, 1];
  symSet[15, 5] := [9];
  symSet[15, 6] := [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14];
  symSet[15, 7] := [7, 8, 9, 10, 11, 12, 13, 14, 15];
  symSet[15, 8] := [];
  symSet[16, 0] := [1, 2, 6];
  symSet[16, 1] := [7, 8, 10, 12];
  symSet[16, 2] := [2, 10];
  symSet[16, 3] := [0, 2, 3, 9, 12, 14, 15];
  symSet[16, 4] := [1];
  symSet[16, 5] := [9];
  symSet[16, 6] := [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14];
  symSet[16, 7] := [7, 8, 9, 10, 11, 12, 13, 14, 15];
  symSet[16, 8] := [];
  symSet[17, 0] := [1];
  symSet[17, 1] := [7, 8, 10, 12];
  symSet[17, 2] := [2];
  symSet[17, 3] := [0, 2, 3, 9, 12, 14, 15];
  symSet[17, 4] := [1];
  symSet[17, 5] := [9];
  symSet[17, 6] := [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14];
  symSet[17, 7] := [7, 8, 9, 10, 11, 12, 13, 14, 15];
  symSet[17, 8] := [];
  symSet[18, 0] := [];
  symSet[18, 1] := [1];
  symSet[18, 2] := [];
  symSet[18, 3] := [];
  symSet[18, 4] := [14, 15];
  symSet[18, 5] := [0, 1, 2, 3, 4, 5, 6, 7, 8, 9];
  symSet[18, 6] := [];
  symSet[18, 7] := [];
  symSet[18, 8] := [];
  symSet[19, 0] := [];
  symSet[19, 1] := [];
  symSet[19, 2] := [];
  symSet[19, 3] := [];
  symSet[19, 4] := [14, 15];
  symSet[19, 5] := [0, 1, 2, 3, 4, 5, 6, 7, 8, 9];
  symSet[19, 6] := [];
  symSet[19, 7] := [];
  symSet[19, 8] := [];
  symSet[20, 0] := [8, 12];
  symSet[20, 1] := [0, 2];
  symSet[20, 2] := [];
  symSet[20, 3] := [4, 5, 6, 7];
  symSet[20, 4] := [6, 7, 8, 9, 10, 11, 12];
  symSet[20, 5] := [];
  symSet[20, 6] := [];
  symSet[20, 7] := [9, 12];
  symSet[20, 8] := [];
  symSet[21, 0] := [1, 2, 3, 4, 5, 6, 15];
  symSet[21, 1] := [1, 7, 8, 10, 12];
  symSet[21, 2] := [2];
  symSet[21, 3] := [0, 3, 4, 6, 7, 10, 12, 14, 15];
  symSet[21, 4] := [6, 13];
  symSet[21, 5] := [0, 1, 2];
  symSet[21, 6] := [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15];
  symSet[21, 7] := [0, 3, 4, 6];
  symSet[21, 8] := [];
  symSet[22, 0] := [1, 2, 3, 4, 5, 6, 12, 15];
  symSet[22, 1] := [0, 1, 2, 7, 8, 10, 12];
  symSet[22, 2] := [2, 5, 6, 9, 11, 12, 13];
  symSet[22, 3] := [0, 2, 3, 4, 5, 6, 7, 10, 11, 12, 13, 14, 15];
  symSet[22, 4] := [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15];
  symSet[22, 5] := [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15];
  symSet[22, 6] := [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15];
  symSet[22, 7] := [0, 3, 4, 6, 9, 12];
  symSet[22, 8] := [];
  symSet[23, 0] := [1, 2, 3, 4, 5, 6, 15];
  symSet[23, 1] := [0, 1, 2, 7, 8, 10, 12];
  symSet[23, 2] := [2, 5, 6, 9, 11, 12, 13];
  symSet[23, 3] := [0, 2, 3, 4, 5, 6, 7, 10, 11, 12, 13, 14, 15];
  symSet[23, 4] := [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15];
  symSet[23, 5] := [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15];
  symSet[23, 6] := [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15];
  symSet[23, 7] := [0, 3, 4, 6, 9, 12];
  symSet[23, 8] := [];
  symSet[24, 0] := [1, 6, 8, 14];
  symSet[24, 1] := [1, 3, 4, 5, 6, 7, 8, 10, 12];
  symSet[24, 2] := [1, 2, 3, 4, 14, 15];
  symSet[24, 3] := [0, 2, 3, 9, 11, 12, 13, 14, 15];
  symSet[24, 4] := [1];
  symSet[24, 5] := [9];
  symSet[24, 6] := [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14];
  symSet[24, 7] := [7, 8, 9, 10, 11, 12, 13, 14, 15];
  symSet[24, 8] := [];
  symSet[25, 0] := [1, 6, 14];
  symSet[25, 1] := [3, 4, 5, 6, 7, 8, 10, 12];
  symSet[25, 2] := [1, 2, 3, 14, 15];
  symSet[25, 3] := [0, 2, 3, 9, 11, 12, 13, 14, 15];
  symSet[25, 4] := [1];
  symSet[25, 5] := [9];
  symSet[25, 6] := [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14];
  symSet[25, 7] := [7, 8, 9, 10, 11, 12, 13, 14, 15];
  symSet[25, 8] := [];
  symSet[26, 0] := [1, 6];
  symSet[26, 1] := [7, 8, 10, 12];
  symSet[26, 2] := [1, 2, 3, 14, 15];
  symSet[26, 3] := [0, 2, 3, 9, 11, 12, 13, 14, 15];
  symSet[26, 4] := [1];
  symSet[26, 5] := [9];
  symSet[26, 6] := [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14];
  symSet[26, 7] := [7, 8, 9, 10, 11, 12, 13, 14, 15];
  symSet[26, 8] := [];
  symSet[27, 0] := [14, 15];
  symSet[27, 1] := [1];
  symSet[27, 2] := [1, 3, 14, 15];
  symSet[27, 3] := [11, 13];
  symSet[27, 4] := [];
  symSet[27, 5] := [];
  symSet[27, 6] := [];
  symSet[27, 7] := [];
  symSet[27, 8] := [];
  symSet[28, 0] := [];
  symSet[28, 1] := [];
  symSet[28, 2] := [1, 3, 14, 15];
  symSet[28, 3] := [11, 13];
  symSet[28, 4] := [];
  symSet[28, 5] := [];
  symSet[28, 6] := [];
  symSet[28, 7] := [];
  symSet[28, 8] := [];
  symSet[29, 0] := [2, 4, 5];
  symSet[29, 1] := [];
  symSet[29, 2] := [];
  symSet[29, 3] := [4, 5, 6, 7];
  symSet[29, 4] := [6, 7, 8, 9, 10, 11, 12];
  symSet[29, 5] := [];
  symSet[29, 6] := [];
  symSet[29, 7] := [];
  symSet[29, 8] := [];
  symSet[30, 0] := [1];
  symSet[30, 1] := [7, 8, 10, 12];
  symSet[30, 2] := [2];
  symSet[30, 3] := [0, 3, 10, 12, 14, 15];
  symSet[30, 4] := [];
  symSet[30, 5] := [];
  symSet[30, 6] := [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14];
  symSet[30, 7] := [];
  symSet[30, 8] := [];
  symSet[31, 0] := [1, 6, 8, 14];
  symSet[31, 1] := [1, 3, 4, 5, 6, 7, 8, 10, 12];
  symSet[31, 2] := [1, 2, 3, 14, 15];
  symSet[31, 3] := [0, 2, 3, 9, 11, 12, 13, 14, 15];
  symSet[31, 4] := [1];
  symSet[31, 5] := [9];
  symSet[31, 6] := [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14];
  symSet[31, 7] := [7, 8, 9, 10, 11, 12, 13, 14, 15];
  symSet[31, 8] := [];
  symSet[32, 0] := [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15];
  symSet[32, 1] := [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15];
  symSet[32, 2] := [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15];
  symSet[32, 3] := [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15];
  symSet[32, 4] := [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15];
  symSet[32, 5] := [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15];
  symSet[32, 6] := [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15];
  symSet[32, 7] := [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15];
  symSet[32, 8] := [0];
  symSet[33, 0] := [10];
  symSet[33, 1] := [];
  symSet[33, 2] := [8];
  symSet[33, 3] := [8, 11, 13];
  symSet[33, 4] := [];
  symSet[33, 5] := [];
  symSet[33, 6] := [];
  symSet[33, 7] := [5];
  symSet[33, 8] := [];
  symSet[34, 0] := [];
  symSet[34, 1] := [7, 8, 10, 12];
  symSet[34, 2] := [2];
  symSet[34, 3] := [0, 3, 12, 14, 15];
  symSet[34, 4] := [];
  symSet[34, 5] := [];
  symSet[34, 6] := [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14];
  symSet[34, 7] := [];
  symSet[34, 8] := [];
end;


end.   (* DelphiParser *)
