// Generated by ParserBuilder @ 27/05/2001 4:51:15 PM

unit Win32OnlyScanner;

(* NOTE: Any changes made to this file may be overwritten when it gets regenerated
  from within ParserBuilder *)

interface

uses
  Windows, Messages, SysUtils, Classes;

const
  BlkSize = 16384;
  TAB = #09;
  _LF = #10;
  _CR = #13;
  _EF = #0;
  EF = #0;
  _EL = _CR;
  LineEnds: array[0..2] of char = (#13, #10, #0);
  CRLF = #13#10;

type
  TBufBlock = array [0..BlkSize - 1] of char;
  TCocoBuffer = array [0..1024] of ^TBufBlock;
  TStartTable = array [0..255] of integer;
  TGetCH = procedure(pos: longint; Var retCh : Char) of object;
  TCocoErrorProc = procedure(nr, line, col: integer; pos: integer) of object;

type
  TWin32OnlyScanner = class(TObject)
  private
    lastCh,
    ch: char;       (*current input character*)
    curLine: integer;    (*current input line (may be higher than line)*)
    lineStart: longint;    (*start position of current line*)
    apx: longint;    (*length of appendix (CONTEXT phrase)*)
    oldEols: integer;    (*number of _EOLs in a comment*)
    bp, bp0: longint;    (*current position in buf
                           (bp0: position of current token)*)
    LBlkSize: longint;    (*BlkSize*)
    inputLen: longint;    (*source file size*)
    buf: TCocoBuffer;     (*source buffer for low-level access*)
    start: TStartTable; (*start state for every character*)
    CurrentCh: TGetCH;
    {----------------}
    FnextLen: integer;
    Fpos: integer;
    Fcol: integer;
    FnextCol: integer;
    FnextPos: integer;
    Flen: integer;
    FnextLine: integer;
    Fline: integer;
    Fdirectory: string;
    FError: TCocoErrorProc;
    FOutputDirectory: string;
    procedure Err(nr, line, col: integer; pos: longint);
    procedure NextCh;
    function Comment: boolean;
    procedure CapChAt(pos: longint; var retChar : Char);
    procedure DisposeBuf;
  protected
  public
    src: TStringStream;         (*source/list files. To be opened by the main pgm*)
    lst: TStringStream;
    Ferrors: integer;
    constructor Create;
    destructor Destroy; override;
    procedure Get(var sym: integer);
    (* Gets next symbol from source file *)
    procedure GetString(pos: longint; len: integer; var s: string);
    (* Retrieves exact string of max length len from position pos in source file *)
    procedure GetName(pos: longint; len: integer; var s: string);
    (* Retrieves name of symbol of length len at position pos in source file *)
    procedure CharAt(pos: longint; var retChar : Char);
    (* Returns exact character at position pos in source file *)
    procedure _Reset;
    (* Reads and stores source file internally *)
    property Error: TCocoErrorProc read FError write FError;
  published
    { Published declarations }
    property directory: string read Fdirectory write Fdirectory;
    (*of source file*)
    property OutputDirectory: string read FOutputDirectory write FOutputDirectory;
    property line: integer read Fline write Fline;
    (*line and column of current symbol*)
    property col: integer read Fcol write Fcol;
    (*line and column of current symbol*)
    property len: integer read Flen write Flen;      (*length of current symbol*)
    property pos: integer read Fpos write Fpos;
    (*file position of current symbol*)
    property nextLine: integer read FnextLine write FnextLine;
    (*line of lookahead symbol*)
    property nextCol: integer read FnextCol write FnextCol;
    (*column of lookahead symbol*)
    property nextLen: integer read FnextLen write FnextLen;
    (*length of lookahead symbol*)
    property nextPos: integer read FnextPos write FnextPos;
    (*file position of lookahead symbol*)
    property errors: integer read Ferrors write Ferrors;
    (*number of detected errors*)
  end;


implementation



const
  no_Sym = 9; (*error token code*)
  (* not only for errors but also for not finished states of scanner analysis *)
  _EOF = #26; (*MS-DOS _EOF*)

Procedure TWin32OnlyScanner.CapChAt(pos: longint; var retChar : Char);
var
  ch: char;
begin
  if pos >= inputLen then
  begin
    retChar := EF;
    EXIT;
  end;
  ch := upcase(buf[pos div LBlkSize]^[pos mod LBlkSize]);
  if ch <> _EOF then retChar := ch
  else
    retChar := EF
end;

Procedure TWin32OnlyScanner.CharAt(pos: longint; var retChar : Char);
var
  ch: char;
begin
  if pos >= inputLen then
  begin
    retChar := EF;
    EXIT;
  end;
  ch := buf[pos div LBlkSize]^[pos mod LBlkSize];
  if ch <> _EOF then retChar := ch
  else
    retChar := EF
end;

function TWin32OnlyScanner.Comment: boolean;
label
  999;
  VAR
    level: INTEGER;
    oldLineStart,startLine : LONGINT;
  BEGIN
    level := 1; oldLineStart := lineStart;
IF (ch = '(') THEN BEGIN
  
NextCh;
  
IF (ch = '*') THEN BEGIN
    
NextCh;
    
WHILE TRUE DO BEGIN
      
IF (ch = '*') THEN BEGIN
        
NextCh;
        
IF (ch = ')') THEN BEGIN
          
DEC(level); NextCh;
          
IF level = 0 THEN BEGIN Comment := TRUE; GOTO 999; END
        
END
      
END ELSE IF (ch = '(') THEN BEGIN
        
NextCh;
        
IF (ch = '*') THEN BEGIN INC(level); NextCh END
      
END ELSE IF ch = EF THEN BEGIN Comment := FALSE; GOTO 999; END
      
ELSE NextCh;
    
END; (* WHILE TRUE *)
  
END ELSE BEGIN
    
IF (ch = _CR) OR (ch = _LF) THEN BEGIN
      
DEC(curLine); lineStart := oldLineStart
    
END;
    
DEC(bp); ch := lastCh;
  
END;

END;

Comment := FALSE;
    999:
end;


procedure TWin32OnlyScanner.Err(nr, line, col, pos: integer);
begin
  INC(Ferrors)
end;

procedure TWin32OnlyScanner.Get(var sym: integer);
var
  state: integer;

  function Equal(s: string): boolean;
  var
    i: integer;
    q: longint;
    cc : Char; // Current Char returned from modifed TGetCh
  begin
    if nextLen <> Length(s) then
    begin
      Equal := False;
      EXIT
    end;
    i := 1;
    q := bp0;
    while i <= nextLen do
    begin
      CurrentCh(q,cc);
      if cc <> s[i] then
      begin
        Equal := False;
        EXIT
      end;
      INC(i);
      INC(q)
    end;
    Equal := True
  end;

  procedure CheckLiteral;
  Var cc : Char;
  begin
    CurrentCh(bp0,cc);
CASE cc OF
    
  '}': IF Equal('}') THEN BEGIN sym := 8; 
          
 END;
    
ELSE BEGIN END
    
END
  end;

begin (*Get*)
  WHILE (ch = ' ') OR
        
((ch >= CHR(1)) AND (ch <= CHR(31))) DO NextCh;
  
IF ((ch = '(')) AND Comment THEN BEGIN Get(sym); EXIT; END;
  pos := nextPos;
  nextPos := bp;
  col := nextCol;
  nextCol := bp - lineStart;
  line := nextLine;
  nextLine := curLine;
  len := nextLen;
  nextLen := 0;
  apx := 0;
  state := start[Ord(ch)];
  bp0 := bp;
  while True do
  begin
    NextCh;
    INC(FnextLen);
    case state of
       1  : IF ((ch >= '0') AND (ch <= '9') OR
             
(ch >= 'A') AND (ch <= 'Z') OR
             
(ch = '_')) THEN BEGIN 
           
END ELSE BEGIN sym := 1; EXIT; END;
     
  2  : IF ((ch = CHR(0)) OR
             
(ch >= ' ') AND (ch <= '!') OR
             
(ch >= '#')) THEN BEGIN 
           
END ELSE IF (ch = '"') THEN BEGIN state := 4; 
           
END ELSE BEGIN sym := no_Sym; EXIT; END;
     
  3  : IF ((ch = CHR(0)) OR
             
(ch >= ' ') AND (ch <= '&') OR
             
(ch >= '(')) THEN BEGIN 
           
END ELSE IF (ch = CHR(39)) THEN BEGIN state := 4; 
           
END ELSE BEGIN sym := no_Sym; EXIT; END;
     
  4  : BEGIN sym := 2; EXIT; END;
     
  5  : BEGIN sym := 3; CheckLiteral; EXIT; END;
     
  6  : IF (ch = 'F') THEN BEGIN state := 7; 
           
END ELSE BEGIN sym := no_Sym; EXIT; END;
     
  7  : IF (ch = 'D') THEN BEGIN state := 8; 
           
END ELSE BEGIN sym := no_Sym; EXIT; END;
     
  8  : IF (ch = 'E') THEN BEGIN state := 9; 
           
END ELSE BEGIN sym := no_Sym; EXIT; END;
     
  9  : IF (ch = 'F') THEN BEGIN state := 10; 
           
END ELSE BEGIN sym := no_Sym; EXIT; END;
     
  10  : BEGIN sym := 4; EXIT; END;
     
  11  : BEGIN sym := 5; EXIT; END;
     
  12  : IF (ch = 'S') THEN BEGIN state := 13; 
           
END ELSE BEGIN sym := no_Sym; EXIT; END;
     
  13  : IF (ch = 'E') THEN BEGIN state := 14; 
           
END ELSE BEGIN sym := no_Sym; EXIT; END;
     
  14  : IF (ch = '}') THEN BEGIN state := 15; 
           
END ELSE BEGIN sym := no_Sym; EXIT; END;
     
  15  : BEGIN sym := 6; EXIT; END;
     
  16  : IF (ch = 'D') THEN BEGIN state := 17; 
           
END ELSE BEGIN sym := no_Sym; EXIT; END;
     
  17  : IF (ch = 'I') THEN BEGIN state := 18; 
           
END ELSE BEGIN sym := no_Sym; EXIT; END;
     
  18  : IF (ch = 'F') THEN BEGIN state := 19; 
           
END ELSE BEGIN sym := no_Sym; EXIT; END;
     
  19  : IF (ch = '}') THEN BEGIN state := 20; 
           
END ELSE BEGIN sym := no_Sym; EXIT; END;
     
  20  : BEGIN sym := 7; EXIT; END;
     
  21  : IF (ch = '$') THEN BEGIN state := 23; 
           
END ELSE BEGIN sym := 3; CheckLiteral; EXIT; END;
     
  22  : IF ((ch >= '0') AND (ch <= '9') OR
             
(ch >= 'A') AND (ch <= 'H') OR
             
(ch >= 'J') AND (ch <= 'Z') OR
             
(ch = '_')) THEN BEGIN state := 1; 
           
END ELSE IF (ch = 'I') THEN BEGIN state := 24; 
           
END ELSE BEGIN sym := 1; EXIT; END;
     
  23  : IF (ch = 'I') THEN BEGIN state := 6; 
           
END ELSE IF (ch = 'E') THEN BEGIN state := 25; 
           
END ELSE BEGIN sym := no_Sym; EXIT; END;
     
  24  : IF ((ch >= '0') AND (ch <= '9') OR
             
(ch >= 'A') AND (ch <= 'M') OR
             
(ch >= 'O') AND (ch <= 'Z') OR
             
(ch = '_')) THEN BEGIN state := 1; 
           
END ELSE IF (ch = 'N') THEN BEGIN state := 26; 
           
END ELSE BEGIN sym := 1; EXIT; END;
     
  25  : IF (ch = 'L') THEN BEGIN state := 12; 
           
END ELSE IF (ch = 'N') THEN BEGIN state := 16; 
           
END ELSE BEGIN sym := no_Sym; EXIT; END;
     
  26  : IF ((ch >= '0') AND (ch <= '9') OR
             
(ch >= 'A') AND (ch <= 'T') OR
             
(ch >= 'V') AND (ch <= 'Z') OR
             
(ch = '_')) THEN BEGIN state := 1; 
           
END ELSE IF (ch = 'U') THEN BEGIN state := 27; 
           
END ELSE BEGIN sym := 1; EXIT; END;
     
  27  : IF ((ch >= '0') AND (ch <= '9') OR
             
(ch >= 'A') AND (ch <= 'W') OR
             
(ch >= 'Y') AND (ch <= 'Z') OR
             
(ch = '_')) THEN BEGIN state := 1; 
           
END ELSE IF (ch = 'X') THEN BEGIN state := 28; 
           
END ELSE BEGIN sym := 1; EXIT; END;
     
  28  : IF ((ch >= '0') AND (ch <= '9') OR
             
(ch >= 'A') AND (ch <= 'Z') OR
             
(ch = '_')) THEN BEGIN state := 1; 
           
END ELSE IF (ch = '}') THEN BEGIN state := 11; 
           
END ELSE BEGIN sym := 1; EXIT; END;
     
  29  : BEGIN sym := 0; ch := #0; DEC(bp); EXIT END;
      else
      begin
        sym := no_Sym;
        EXIT (*NextCh already done*)
      end;
    end
  end
end;


procedure TWin32OnlyScanner.GetName(pos, len: integer; var s: string);
var
  i: integer;
  p: longint;
  cc : Char;
begin
  if len > 255 then len := 255;
  p := pos;
  i := 1;
  SetLength(S,Len);
  while i <= len do
  begin
    CurrentCh(p,cc);
    s[i] := cc;
    INC(i);
    INC(p)
  end;
end;


procedure TWin32OnlyScanner.GetString(pos, len: integer; var s: string);
var
  i: integer;
  p: longint;
  cc : Char;
begin
  if len > 255 then len := 255;
  p := pos;
  i := 1;
  setLength(S,len);
  while i <= len do
  begin
    CharAt(p,cc);
    s[i] := cc;
    INC(i);
    INC(p)
  end;
end;

procedure TWin32OnlyScanner.NextCh;
  (* Return global variable ch *)
  Var cc : Char;
begin
  lastCh := ch;
  INC(bp);
  CurrentCh(bp,cc);
  ch := cc;
  if (ch = _EL) or (ch = _LF) and (lastCh <> _EL) then
  begin
    INC(curLine);
    lineStart := bp
  end
end;


procedure TWin32OnlyScanner._Reset;
var
  len: longint;
  i, Read: integer;
  AmtTransferred: Integer;
begin (*assert: src has been opened*)
//  len := FileSize(src);
  Len := src.Size;
  DisposeBuf;
  i := 0;
  inputLen := len;
  while len > LBlkSize do
  begin
    NEW(buf[i]);
    Read := BlkSize;
//    BlockRead(src, buf[i]^, Read,AmtTransferred);
    AmtTransferred := src.Read(buf[i]^, Read);
    len := len - AmtTransferred;
    INC(i)
  end;
  NEW(buf[i]);
  Read := len;
  //AmtTransferred :=
  src.Read(buf[i]^, Read);
  buf[i]^[Read] := EF;
  curLine := 1;
  lineStart := -2;
  bp := -1;
  oldEols := 0;
  apx := 0;
  errors := 0;
  NextCh;
end;

constructor TWin32OnlyScanner.Create;
begin
  inherited;
  lst:= TStringStream.Create('');
  src := NIL;
  CurrentCh := CapChAt;
  
start[0   ] := 29  ; start[1   ] := 30  ; start[2   ] := 30  ; start[3   ] := 30  ; 
  
start[4   ] := 30  ; start[5   ] := 30  ; start[6   ] := 30  ; start[7   ] := 30  ; 
  
start[8   ] := 30  ; start[9   ] := 30  ; start[10   ] := 30  ; start[11   ] := 30  ; 
  
start[12   ] := 30  ; start[13   ] := 30  ; start[14   ] := 30  ; start[15   ] := 30  ; 
  
start[16   ] := 30  ; start[17   ] := 30  ; start[18   ] := 30  ; start[19   ] := 30  ; 
  
start[20   ] := 30  ; start[21   ] := 30  ; start[22   ] := 30  ; start[23   ] := 30  ; 
  
start[24   ] := 30  ; start[25   ] := 30  ; start[26   ] := 30  ; start[27   ] := 30  ; 
  
start[28   ] := 30  ; start[29   ] := 30  ; start[30   ] := 30  ; start[31   ] := 30  ; 
  
start[32   ] := 30  ; start[33   ] := 30  ; start[34   ] := 2  ; start[35   ] := 30  ; 
  
start[36   ] := 30  ; start[37   ] := 5  ; start[38   ] := 30  ; start[39   ] := 3  ; 
  
start[40   ] := 5  ; start[41   ] := 5  ; start[42   ] := 5  ; start[43   ] := 30  ; 
  
start[44   ] := 5  ; start[45   ] := 5  ; start[46   ] := 5  ; start[47   ] := 5  ; 
  
start[48   ] := 1  ; start[49   ] := 1  ; start[50   ] := 1  ; start[51   ] := 1  ; 
  
start[52   ] := 1  ; start[53   ] := 1  ; start[54   ] := 1  ; start[55   ] := 1  ; 
  
start[56   ] := 1  ; start[57   ] := 1  ; start[58   ] := 5  ; start[59   ] := 5  ; 
  
start[60   ] := 30  ; start[61   ] := 30  ; start[62   ] := 30  ; start[63   ] := 30  ; 
  
start[64   ] := 5  ; start[65   ] := 1  ; start[66   ] := 1  ; start[67   ] := 1  ; 
  
start[68   ] := 1  ; start[69   ] := 1  ; start[70   ] := 1  ; start[71   ] := 1  ; 
  
start[72   ] := 1  ; start[73   ] := 1  ; start[74   ] := 1  ; start[75   ] := 1  ; 
  
start[76   ] := 22  ; start[77   ] := 1  ; start[78   ] := 1  ; start[79   ] := 1  ; 
  
start[80   ] := 1  ; start[81   ] := 1  ; start[82   ] := 1  ; start[83   ] := 1  ; 
  
start[84   ] := 1  ; start[85   ] := 1  ; start[86   ] := 1  ; start[87   ] := 1  ; 
  
start[88   ] := 1  ; start[89   ] := 1  ; start[90   ] := 1  ; start[91   ] := 30  ; 
  
start[92   ] := 30  ; start[93   ] := 30  ; start[94   ] := 30  ; start[95   ] := 1  ; 
  
start[96   ] := 30  ; start[97   ] := 30  ; start[98   ] := 30  ; start[99   ] := 30  ; 
  
start[100   ] := 30  ; start[101   ] := 30  ; start[102   ] := 30  ; start[103   ] := 30  ; 
  
start[104   ] := 30  ; start[105   ] := 30  ; start[106   ] := 30  ; start[107   ] := 30  ; 
  
start[108   ] := 30  ; start[109   ] := 30  ; start[110   ] := 30  ; start[111   ] := 30  ; 
  
start[112   ] := 30  ; start[113   ] := 30  ; start[114   ] := 30  ; start[115   ] := 30  ; 
  
start[116   ] := 30  ; start[117   ] := 30  ; start[118   ] := 30  ; start[119   ] := 30  ; 
  
start[120   ] := 30  ; start[121   ] := 30  ; start[122   ] := 30  ; start[123   ] := 21  ; 
  
start[124   ] := 30  ; start[125   ] := 5  ; start[126   ] := 30  ; start[127   ] := 30  ; 
  
start[128   ] := 30  ; start[129   ] := 30  ; start[130   ] := 30  ; start[131   ] := 30  ; 
  
start[132   ] := 30  ; start[133   ] := 30  ; start[134   ] := 30  ; start[135   ] := 30  ; 
  
start[136   ] := 30  ; start[137   ] := 30  ; start[138   ] := 30  ; start[139   ] := 30  ; 
  
start[140   ] := 30  ; start[141   ] := 30  ; start[142   ] := 30  ; start[143   ] := 30  ; 
  
start[144   ] := 30  ; start[145   ] := 30  ; start[146   ] := 30  ; start[147   ] := 30  ; 
  
start[148   ] := 30  ; start[149   ] := 30  ; start[150   ] := 30  ; start[151   ] := 30  ; 
  
start[152   ] := 30  ; start[153   ] := 30  ; start[154   ] := 30  ; start[155   ] := 30  ; 
  
start[156   ] := 30  ; start[157   ] := 30  ; start[158   ] := 30  ; start[159   ] := 30  ; 
  
start[160   ] := 30  ; start[161   ] := 30  ; start[162   ] := 30  ; start[163   ] := 30  ; 
  
start[164   ] := 30  ; start[165   ] := 30  ; start[166   ] := 30  ; start[167   ] := 30  ; 
  
start[168   ] := 30  ; start[169   ] := 30  ; start[170   ] := 30  ; start[171   ] := 30  ; 
  
start[172   ] := 30  ; start[173   ] := 30  ; start[174   ] := 30  ; start[175   ] := 30  ; 
  
start[176   ] := 30  ; start[177   ] := 30  ; start[178   ] := 30  ; start[179   ] := 30  ; 
  
start[180   ] := 30  ; start[181   ] := 30  ; start[182   ] := 30  ; start[183   ] := 30  ; 
  
start[184   ] := 30  ; start[185   ] := 30  ; start[186   ] := 30  ; start[187   ] := 30  ; 
  
start[188   ] := 30  ; start[189   ] := 30  ; start[190   ] := 30  ; start[191   ] := 30  ; 
  
start[192   ] := 30  ; start[193   ] := 30  ; start[194   ] := 30  ; start[195   ] := 30  ; 
  
start[196   ] := 30  ; start[197   ] := 30  ; start[198   ] := 30  ; start[199   ] := 30  ; 
  
start[200   ] := 30  ; start[201   ] := 30  ; start[202   ] := 30  ; start[203   ] := 30  ; 
  
start[204   ] := 30  ; start[205   ] := 30  ; start[206   ] := 30  ; start[207   ] := 30  ; 
  
start[208   ] := 30  ; start[209   ] := 30  ; start[210   ] := 30  ; start[211   ] := 30  ; 
  
start[212   ] := 30  ; start[213   ] := 30  ; start[214   ] := 30  ; start[215   ] := 30  ; 
  
start[216   ] := 30  ; start[217   ] := 30  ; start[218   ] := 30  ; start[219   ] := 30  ; 
  
start[220   ] := 30  ; start[221   ] := 30  ; start[222   ] := 30  ; start[223   ] := 30  ; 
  
start[224   ] := 30  ; start[225   ] := 30  ; start[226   ] := 30  ; start[227   ] := 30  ; 
  
start[228   ] := 30  ; start[229   ] := 30  ; start[230   ] := 30  ; start[231   ] := 30  ; 
  
start[232   ] := 30  ; start[233   ] := 30  ; start[234   ] := 30  ; start[235   ] := 30  ; 
  
start[236   ] := 30  ; start[237   ] := 30  ; start[238   ] := 30  ; start[239   ] := 30  ; 
  
start[240   ] := 30  ; start[241   ] := 30  ; start[242   ] := 30  ; start[243   ] := 30  ; 
  
start[244   ] := 30  ; start[245   ] := 30  ; start[246   ] := 30  ; start[247   ] := 30  ; 
  
start[248   ] := 30  ; start[249   ] := 30  ; start[250   ] := 30  ; start[251   ] := 30  ; 
  
start[252   ] := 30  ; start[253   ] := 30  ; start[254   ] := 30  ; start[255   ] := 30  ; 
  Error := Err;
  LBlkSize := BlkSize;
  lastCh := EF;
end;

destructor TWin32OnlyScanner.Destroy;
begin
  if (src <> NIL) then
    src.Free;
  lst.Free;
  DisposeBuf;
  inherited;
end;

procedure TWin32OnlyScanner.DisposeBuf;
var
  idx: integer;
begin
  for idx := 1024 downto 0 do
  begin
    if buf[idx] <> nil then
      Dispose(buf[idx]);
    buf[idx] := nil;
  end;
end;



end. (* Win32OnlyScanner *)
