unit CocoEditController;

interface

uses
  Windows, Messages, SysUtils, Classes,
  CompilerObj;

type
  TCocoEditController = class(TComponent)
  private
    FCompiler: TCompiler;
    FOriginalATGText: string;
    FEditedObject: TObject;
    FModifiedATGText: string;
    procedure SetCompiler(const Value: TCompiler);
    procedure SetEditedObject(const Value: TObject);
    procedure SetOriginalATGText(const Value: string);
    procedure SetModifiedATGText(const Value: string);
    { Private declarations }
  protected
    { Protected declarations }
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure ApplyEdit;
  published
    { Published declarations }
    property Compiler: TCompiler read FCompiler write SetCompiler;
    property OriginalATGText: string read FOriginalATGText write SetOriginalATGText;
    property ModifiedATGText: string read FModifiedATGText write SetModifiedATGText;
    property EditedObject: TObject read FEditedObject write SetEditedObject;
  end;

implementation

{ TCocoEditController }

procedure TCocoEditController.ApplyEdit;
begin
  if (FEditedObject <> nil) then
  begin
  end;
end;

constructor TCocoEditController.Create(AOwner: TComponent);
begin
  inherited;
  FCompiler := nil;
end;

destructor TCocoEditController.Destroy;
begin
  inherited;
end;

procedure TCocoEditController.SetCompiler(const Value: TCompiler);
begin
  FCompiler := Value;
end;

procedure TCocoEditController.SetEditedObject(const Value: TObject);
begin
  FEditedObject := Value;
end;

procedure TCocoEditController.SetModifiedATGText(const Value: string);
begin
  FModifiedATGText := Value;
end;

procedure TCocoEditController.SetOriginalATGText(const Value: string);
begin
  FOriginalATGText := Value;
end;

end.
