// Generated by ParserBuilder @ 14/04/2002 10:45:32 AM

unit EOFParser;

(* NOTE: Any changes made to this file may be overwritten when it gets regenerated
  from within ParserBuilder - unless you run the Delphi Import command*)


interface

uses
  Windows, Messages, SysUtils, Classes, Dialogs, EOFScanner;


const
  maxT = 0;
  maxP = 256;
  minErrDist = 2;  (* minimal distance (good tokens) between two errors *)
  setsize = 16;  (* sets are stored in 16 bits *)

type
  BITSET = set of 0..15;
  TSymbolSet = array [0..maxT div setsize] of BITSET;



type
  TEOFParser = class(TEOFScanner)
  private
    FSuccessful: boolean;
    {PBPRIVATE}
    
    {ENDPBPRIVATE}
    procedure PerformGet;
    procedure SynError(errNo: Integer);
    procedure SemError(errNo: Integer);
    function _In(var s: TSymbolSet; x: Integer): boolean;
    procedure Expect(n: Integer);
    procedure ExpectWeak(n, follow: Integer);
    function WeakSeparator(n, syFol, repFol: Integer): boolean;
    function GetSuccessful: boolean;
    procedure SetSourceString(const Value: string);
    

  protected
    {PBPROTECTED}
     
    {ENDPBPROTECTED}
  public
    {PBPUBLIC}
    
    {ENDPBPUBLIC}
    constructor Create;
    destructor Destroy; override;
    procedure Parse;
    procedure LexString(var Lex: string);
    procedure LexName(var Lex: string);
    procedure LookAheadString(var Lex: string);
    procedure LookAheadName(var Lex: string);
  published
    property Successful: boolean read GetSuccessful;
    property SourceString: string write SetSourceString;
    {PBPUBLISHED}
    
    {ENDPBPUBLISHED}
  end;

implementation

var
  symSet: array [0..0] of TSymbolSet;
  errDist: integer;
  sym: integer;

{  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-
   + For ParserBuilder's Delphi import function to work,        -
   + you must place your code in this Arbitrary Source section. -
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+- }

  {PBARBITRARYSOURCE}




  {ENDPBARBITRARYSOURCE}

  { TEOFParser - Generated Methods below}
procedure TEOFParser.SemError(errNo: Integer);
begin
  if errDist >= minErrDist then
  begin
    Error(errNo, line, col, pos);
  end;
  errDist := 0;
end;

procedure TEOFParser.SynError(errNo: Integer);
begin
  if errDist >= minErrDist then
  begin
    Error(errNo, nextLine, nextCol, nextPos);
  end;
  errDist := 0;
end;

procedure TEOFParser.PerformGet;
var
  s: string;
begin
  repeat
    Get(sym);
    if sym <= maxT then
      INC(errDist)
    else
    begin        
    end;
  until sym <= maxT
  end;

function TEOFParser._In(var s: TSymbolSet; x: Integer): boolean;
begin
  _In := x mod setsize in s[x div setsize];
end;

function TEOFParser.GetSuccessful: boolean;
begin
  FSuccessful := errors = 0;
  Result := FSuccessful;
end;

procedure TEOFParser.Expect(n: Integer);
begin
  if Sym = n then PerformGet
  else
    SynError(n);
end;

procedure TEOFParser.ExpectWeak(n, follow: Integer);
begin
  if Sym = n then PerformGet
  else
  begin
    SynError(n);
    while not _In(symSet[follow], Sym) do PerformGet;
  end
end;

function TEOFParser.WeakSeparator(n, syFol, repFol: Integer): boolean;
var
  s: TSymbolSet;
  i: integer;
begin
  if sym = n then
  begin
    PerformGet;
    WeakSeparator := True;
    EXIT;
  end
  else if _In(symSet[repFol], sym) then
  begin
    WeakSeparator := False;
    exit
  end
  else
  begin
    i := 0;
    while i <= maxT div setsize do
    begin
      s[i] := symSet[0, i] + symSet[syFol, i] + symSet[repFol, i];
      INC(i)
    end;
    SynError(n);
    while not _In(s, sym) do PerformGet;
    WeakSeparator := _In(symSet[syFol], sym)
  end
end;

procedure TEOFParser.LexName(var Lex: string);
begin
  GetName(pos, len, Lex)
end;

procedure TEOFParser.LexString(var Lex: string);
begin
  GetString(pos, len, Lex)
end;

procedure TEOFParser.LookAheadName(var Lex: string);
begin
  GetName(nextPos, nextLen, Lex);
end;

procedure TEOFParser.LookAheadString(var Lex: string);
begin
  GetString(nextPos, nextLen, Lex)
end;

procedure TEOFParser.SetSourceString(const Value: string);
begin
  if (src <> nil) then
    src.Free;
  src := TStringStream.Create(Value);
end;



procedure TEOFParser.Parse;
begin
  _Reset; 
  PerformGet;
end;

destructor TEOFParser.Destroy;
begin
  {PBDESTROY}
  
  {ENDPBDESTROY}
  inherited;
end;

constructor TEOFParser.Create;
begin
  inherited;
  {PBCREATE}
  
  {ENDPBCREATE}
  errDist := minErrDist;
  symSet[0, 0] := [];
end;


end.   (* EOFParser *)
