// Generated by ParserBuilder @ 14/04/2002 10:45:32 AM

unit EOFScanner;

(* NOTE: Any changes made to this file may be overwritten when it gets regenerated
  from within ParserBuilder *)

interface

uses
  Windows, Messages, SysUtils, Classes, pbStrLib, Dialogs;

const
  BlkSize = 16384;

type
  TBufBlock = array [0..BlkSize - 1] of char;
  TCocoBuffer = array [0..31] of ^TBufBlock;
  TStartTable = array [0..255] of Integer;
  TGetCH = procedure(pos: longint; var retCh: char) of object;
  TCocoErrorProc = procedure(nr, line, col: Integer; pos: Integer) of object;

type
  TEOFScanner = class(TObject)
  private
    lastCh,
    ch: char;       (*current input character*)
    curLine: Integer;    (*current input line (may be higher than line)*)
    lineStart: longint;    (*start position of current line*)
    apx: longint;    (*length of appendix (CONTEXT phrase)*)
    oldEols: Integer;    (*number of _EOLs in a comment*)
    bp, bp0: longint;    (*current position in buf
                           (bp0: position of current token)*)
    LBlkSize: longint;    (*BlkSize*)
    inputLen: longint;    (*source file size*)
    buf: TCocoBuffer;     (*source buffer for low-level access*)
    start: TStartTable; (*start state for every character*)
    CurrentCh: TGetCH;
    {----------------}
    FnextLen: Integer;
    Fpos: Integer;
    Fcol: Integer;
    FnextCol: Integer;
    FnextPos: Integer;
    Flen: Integer;
    FnextLine: Integer;
    Fline: Integer;
    Fdirectory: string;
    FError: TCocoErrorProc;
    FOutputDirectory: string;
    procedure Err(nr, line, col: Integer; pos: longint);
    procedure NextCh;
    function Comment: boolean;
    procedure CapChAt(pos: longint; var retChar: char);
    procedure DisposeBuf;
  protected
  public
    src: TStringStream;         (*source/list files. To be opened by the main pgm*)
    lst: TStringStream;
    Ferrors: Integer;
    constructor Create;
    destructor Destroy; override;
    procedure Get(var sym: Integer);
    (* Gets next symbol from source file *)
    procedure GetString(pos: longint; len: Integer; var s: string);
    (* Retrieves exact string of max length len from position pos in source file *)
    procedure GetName(pos: longint; len: Integer; var s: string);
    (* Retrieves name of symbol of length len at position pos in source file *)
    procedure CharAt(pos: longint; var retChar: char);
    (* Returns exact character at position pos in source file *)
    procedure _Reset;
    (* Reads and stores source file internally *)
    property Error: TCocoErrorProc read FError write FError;
  published
    { Published declarations }
    property directory: string read Fdirectory write Fdirectory;
    (*of source file*)
    property OutputDirectory: string read FOutputDirectory write FOutputDirectory;
    property line: Integer read Fline write Fline;
    (*line and column of current symbol*)
    property col: Integer read Fcol write Fcol;
    (*line and column of current symbol*)
    property len: Integer read Flen write Flen;      (*length of current symbol*)
    property pos: Integer read Fpos write Fpos;
    (*file position of current symbol*)
    property nextLine: Integer read FnextLine write FnextLine;
    (*line of lookahead symbol*)
    property nextCol: Integer read FnextCol write FnextCol;
    (*column of lookahead symbol*)
    property nextLen: Integer read FnextLen write FnextLen;
    (*length of lookahead symbol*)
    property nextPos: Integer read FnextPos write FnextPos;
    (*file position of lookahead symbol*)
    property errors: Integer read Ferrors write Ferrors;
    (*number of detected errors*)
  end;


implementation



const
  no_Sym = 0; (*error token code*)
  (* not only for errors but also for not finished states of scanner analysis *)
  _EOF = #26; (*MS-DOS _EOF*)

procedure TEOFScanner.CapChAt(pos: longint; var retChar: char);
var
  ch: char;
begin
  if pos >= inputLen then
  begin
    retChar := EF;
    EXIT;
  end;
  ch := upcase(buf[pos div LBlkSize]^[pos mod LBlkSize]);
  if ch <> _EOF then retChar := ch
  else
    retChar := EF
end;

procedure TEOFScanner.CharAt(pos: longint; var retChar: char);
var
  ch: char;
begin
  if pos >= inputLen then
  begin
    retChar := EF;
    EXIT;
  end;
  ch := buf[pos div LBlkSize]^[pos mod LBlkSize];
  if ch <> _EOF then retChar := ch
  else
    retChar := EF
end;

function TEOFScanner.Comment: boolean;
label
  999;
var
  level: integer;
  oldLineStart, startLine: longint;
begin
  level := 1; 
  oldLineStart := lineStart;
  Comment := False;
  999:
end;


procedure TEOFScanner.Err(nr, line, col, pos: Integer);
begin
  INC(Ferrors)
end;

procedure TEOFScanner.Get(var sym: Integer);
var
  state: integer;

  function Equal(s: string): boolean;
  var
    i: integer;
    q: longint;
    cc: char; // Current Char returned from modifed TGetCh
  begin
    if nextLen <> Length(s) then
    begin
      Equal := False;
      EXIT
    end;
    i := 1;
    q := bp0;
    while i <= nextLen do
    begin
      CurrentCh(q, cc);
      if cc <> s[i] then
      begin
        Equal := False;
        EXIT
      end;
      INC(i);
      INC(q)
    end;
    Equal := True
  end;

  procedure CheckLiteral;
  var 
    cc: char;
  begin    
  end;
begin (*Get*)
  if oldEols > 0 then 
  begin 
    DEC(bp); 
    DEC(oldEols); 
    ch := _CR 
  end;
  
  while (ch = ' ') do NextCh;
  pos := nextPos;
  nextPos := bp;
  col := nextCol;
  nextCol := bp - lineStart;
  line := nextLine;
  nextLine := curLine;
  len := nextLen;
  nextLen := 0;
  apx := 0;
  state := start[Ord(ch)];
  bp0 := bp;
  while True do
  begin
    NextCh;
    INC(FnextLen);
    case state of
          
      1: 
      begin 
        sym := 0; 
        ch := #0; 
        DEC(bp); 
        EXIT 
      end;
      else
      begin
        sym := no_Sym;
        EXIT (*NextCh already done*)
      end;
    end
  end
end;


procedure TEOFScanner.GetName(pos, len: Integer; var s: string);
var
  i: integer;
  p: longint;
  cc: char;
begin
  if len > 255 then len := 255;
  p := pos;
  i := 1;
  SetLength(S, Len);
  while i <= len do
  begin
    CurrentCh(p, cc);
    s[i] := cc;
    INC(i);
    INC(p)
  end;
end;


procedure TEOFScanner.GetString(pos, len: Integer; var s: string);
var
  i: integer;
  p: longint;
  cc: char;
begin
  if len > 255 then len := 255;
  p := pos;
  i := 1;
  setLength(S, len);
  while i <= len do
  begin
    CharAt(p, cc);
    s[i] := cc;
    INC(i);
    INC(p)
  end;
end;

procedure TEOFScanner.NextCh;
  (* Return global variable ch *)
var 
  cc: char;
begin
  lastCh := ch;
  INC(bp);
  CurrentCh(bp, cc);
  ch := cc;
  if (ch = _EL) or (ch = _LF) and (lastCh <> _EL) then
  begin
    INC(curLine);
    lineStart := bp
  end
end;


procedure TEOFScanner._Reset;
var
  len: longint;
  i, Read: integer;
  AmtTransferred: integer;
begin (*assert: src has been opened*)
  //  len := FileSize(src);
  Len := src.Size;
  DisposeBuf;
  i := 0;
  inputLen := len;
  while len > LBlkSize do
  begin
    NEW(buf[i]);
    Read := BlkSize;
    //    BlockRead(src, buf[i]^, Read,AmtTransferred);
    AmtTransferred := src.Read(buf[i]^, Read);
    len := len - AmtTransferred;
    INC(i)
  end;
  NEW(buf[i]);
  Read := len;
  //AmtTransferred :=
  src.Read(buf[i]^, Read);
  buf[i]^[Read] := EF;
  curLine := 1;
  lineStart := -2;
  bp := -1;
  oldEols := 0;
  apx := 0;
  errors := 0;
  NextCh;
end;

constructor TEOFScanner.Create;
begin
  inherited;
  lst := TStringStream.Create('');
  src := nil;
  CurrentCh := CharAt;
  
  start[0] := 1; 
  start[1] := 2; 
  start[2] := 2; 
  start[3] := 2; 
  
  start[4] := 2; 
  start[5] := 2; 
  start[6] := 2; 
  start[7] := 2; 
  
  start[8] := 2; 
  start[9] := 2; 
  start[10] := 2; 
  start[11] := 2; 
  
  start[12] := 2; 
  start[13] := 2; 
  start[14] := 2; 
  start[15] := 2; 
  
  start[16] := 2; 
  start[17] := 2; 
  start[18] := 2; 
  start[19] := 2; 
  
  start[20] := 2; 
  start[21] := 2; 
  start[22] := 2; 
  start[23] := 2; 
  
  start[24] := 2; 
  start[25] := 2; 
  start[26] := 2; 
  start[27] := 2; 
  
  start[28] := 2; 
  start[29] := 2; 
  start[30] := 2; 
  start[31] := 2; 
  
  start[32] := 2; 
  start[33] := 2; 
  start[34] := 2; 
  start[35] := 2; 
  
  start[36] := 2; 
  start[37] := 2; 
  start[38] := 2; 
  start[39] := 2; 
  
  start[40] := 2; 
  start[41] := 2; 
  start[42] := 2; 
  start[43] := 2; 
  
  start[44] := 2; 
  start[45] := 2; 
  start[46] := 2; 
  start[47] := 2; 
  
  start[48] := 2; 
  start[49] := 2; 
  start[50] := 2; 
  start[51] := 2; 
  
  start[52] := 2; 
  start[53] := 2; 
  start[54] := 2; 
  start[55] := 2; 
  
  start[56] := 2; 
  start[57] := 2; 
  start[58] := 2; 
  start[59] := 2; 
  
  start[60] := 2; 
  start[61] := 2; 
  start[62] := 2; 
  start[63] := 2; 
  
  start[64] := 2; 
  start[65] := 2; 
  start[66] := 2; 
  start[67] := 2; 
  
  start[68] := 2; 
  start[69] := 2; 
  start[70] := 2; 
  start[71] := 2; 
  
  start[72] := 2; 
  start[73] := 2; 
  start[74] := 2; 
  start[75] := 2; 
  
  start[76] := 2; 
  start[77] := 2; 
  start[78] := 2; 
  start[79] := 2; 
  
  start[80] := 2; 
  start[81] := 2; 
  start[82] := 2; 
  start[83] := 2; 
  
  start[84] := 2; 
  start[85] := 2; 
  start[86] := 2; 
  start[87] := 2; 
  
  start[88] := 2; 
  start[89] := 2; 
  start[90] := 2; 
  start[91] := 2; 
  
  start[92] := 2; 
  start[93] := 2; 
  start[94] := 2; 
  start[95] := 2; 
  
  start[96] := 2; 
  start[97] := 2; 
  start[98] := 2; 
  start[99] := 2; 
  
  start[100] := 2; 
  start[101] := 2; 
  start[102] := 2; 
  start[103] := 2; 
  
  start[104] := 2; 
  start[105] := 2; 
  start[106] := 2; 
  start[107] := 2; 
  
  start[108] := 2; 
  start[109] := 2; 
  start[110] := 2; 
  start[111] := 2; 
  
  start[112] := 2; 
  start[113] := 2; 
  start[114] := 2; 
  start[115] := 2; 
  
  start[116] := 2; 
  start[117] := 2; 
  start[118] := 2; 
  start[119] := 2; 
  
  start[120] := 2; 
  start[121] := 2; 
  start[122] := 2; 
  start[123] := 2; 
  
  start[124] := 2; 
  start[125] := 2; 
  start[126] := 2; 
  start[127] := 2; 
  
  start[128] := 2; 
  start[129] := 2; 
  start[130] := 2; 
  start[131] := 2; 
  
  start[132] := 2; 
  start[133] := 2; 
  start[134] := 2; 
  start[135] := 2; 
  
  start[136] := 2; 
  start[137] := 2; 
  start[138] := 2; 
  start[139] := 2; 
  
  start[140] := 2; 
  start[141] := 2; 
  start[142] := 2; 
  start[143] := 2; 
  
  start[144] := 2; 
  start[145] := 2; 
  start[146] := 2; 
  start[147] := 2; 
  
  start[148] := 2; 
  start[149] := 2; 
  start[150] := 2; 
  start[151] := 2; 
  
  start[152] := 2; 
  start[153] := 2; 
  start[154] := 2; 
  start[155] := 2; 
  
  start[156] := 2; 
  start[157] := 2; 
  start[158] := 2; 
  start[159] := 2; 
  
  start[160] := 2; 
  start[161] := 2; 
  start[162] := 2; 
  start[163] := 2; 
  
  start[164] := 2; 
  start[165] := 2; 
  start[166] := 2; 
  start[167] := 2; 
  
  start[168] := 2; 
  start[169] := 2; 
  start[170] := 2; 
  start[171] := 2; 
  
  start[172] := 2; 
  start[173] := 2; 
  start[174] := 2; 
  start[175] := 2; 
  
  start[176] := 2; 
  start[177] := 2; 
  start[178] := 2; 
  start[179] := 2; 
  
  start[180] := 2; 
  start[181] := 2; 
  start[182] := 2; 
  start[183] := 2; 
  
  start[184] := 2; 
  start[185] := 2; 
  start[186] := 2; 
  start[187] := 2; 
  
  start[188] := 2; 
  start[189] := 2; 
  start[190] := 2; 
  start[191] := 2; 
  
  start[192] := 2; 
  start[193] := 2; 
  start[194] := 2; 
  start[195] := 2; 
  
  start[196] := 2; 
  start[197] := 2; 
  start[198] := 2; 
  start[199] := 2; 
  
  start[200] := 2; 
  start[201] := 2; 
  start[202] := 2; 
  start[203] := 2; 
  
  start[204] := 2; 
  start[205] := 2; 
  start[206] := 2; 
  start[207] := 2; 
  
  start[208] := 2; 
  start[209] := 2; 
  start[210] := 2; 
  start[211] := 2; 
  
  start[212] := 2; 
  start[213] := 2; 
  start[214] := 2; 
  start[215] := 2; 
  
  start[216] := 2; 
  start[217] := 2; 
  start[218] := 2; 
  start[219] := 2; 
  
  start[220] := 2; 
  start[221] := 2; 
  start[222] := 2; 
  start[223] := 2; 
  
  start[224] := 2; 
  start[225] := 2; 
  start[226] := 2; 
  start[227] := 2; 
  
  start[228] := 2; 
  start[229] := 2; 
  start[230] := 2; 
  start[231] := 2; 
  
  start[232] := 2; 
  start[233] := 2; 
  start[234] := 2; 
  start[235] := 2; 
  
  start[236] := 2; 
  start[237] := 2; 
  start[238] := 2; 
  start[239] := 2; 
  
  start[240] := 2; 
  start[241] := 2; 
  start[242] := 2; 
  start[243] := 2; 
  
  start[244] := 2; 
  start[245] := 2; 
  start[246] := 2; 
  start[247] := 2; 
  
  start[248] := 2; 
  start[249] := 2; 
  start[250] := 2; 
  start[251] := 2; 
  
  start[252] := 2; 
  start[253] := 2; 
  start[254] := 2; 
  start[255] := 2; 
  Error := Err;
  LBlkSize := BlkSize;
  lastCh := EF;
end;

destructor TEOFScanner.Destroy;
begin
  if (src <> nil) then
    src.Free;
  lst.Free;
  DisposeBuf;
  inherited;
end;

procedure TEOFScanner.DisposeBuf;
var
  idx: integer;
begin
  for idx := 31 downto 0 do
  begin
    if buf[idx] <> nil then
      Dispose(buf[idx]);
    buf[idx] := nil;
  end;
end;



end. (* EOFScanner *)
