// Generated by ParserBuilder @ 11/04/2002 6:49:51 AM

unit pbCocoImportTestParser;

(* NOTE: Any changes made to this file may be overwritten when it gets regenerated
  from within ParserBuilder *)


interface

uses
  Windows, Messages, SysUtils, Classes, Dialogs, pbStrLib, CompilerObj,
  CocoProduction, CocoProductionPath, CocoFactor, CocoToken, CocoGUITable,
  pbCocoImportTestScanner;


const
  maxT = 60;
  maxP = 61;
  minErrDist = 2;  (* minimal distance (good tokens) between two errors *)
  setsize = 16;  (* sets are stored in 16 bits *)

type
  BITSET = set of 0..15;
  TSymbolSet = array [0..maxT div setsize] of BITSET;



type
  TpbCocoImportTestParser = class(TpbCocoImportTestScanner)
  private
    FSuccessful: boolean;
    fCompiler: TCompiler;
    fOutputStream: TMemoryStream;
    fCollector: string;
    fAppendReturnCnt: Integer;
    fSpaceCnt: Integer;
    FCurrentSection: Integer;
    fInStartOfProduction: boolean;
    fInFactor: boolean;
    fCurrentProduction: TCocoProduction;
    fCurrentProdPath: TCocoProductionPath;
    fCurrentFactor: TCocoFactor;
    fCurrentToken: TCocoToken;
    fIsNoneOrMany: boolean;
    fIsNoneOrOne: boolean;
    fIsWrappedInBraces: boolean;
    fIsBranching: boolean;
    fOpenPunctuation: string;
    fClosePunctuation: string;
    fWrapCount: Integer;
    fMapTokensToPragmas: boolean;
    fCOMPILERFRAME: string;
    fPARSERFRAME: string;
    fSCANNERFRAME: string;
    fCOMPILERTARGET: string;
    fPARSERTARGET: string;
    fSCANNERTARGET: string;
    fTargetDirectory: string;
    fGUITable: TCocoGUITable;
    fClassItemPos: Integer;
    fClassItemLength: Integer;

    procedure Init;
    procedure Final;
    procedure WriteStr(S: string);
    procedure WriteCollector(const S: string);
    procedure CollectLex;
    procedure ResetCollector;
    function GetLexString: string;
    procedure WriteSection;
    procedure WriteSpace;
    procedure ResetAttributeFlags;
    procedure IncWrap;
    procedure DecWrap;
    procedure Skip;
    procedure ResetFormatting;
    procedure InTokens;
    procedure InPragmas;
    procedure AddProduction(const ProdName: string);
    procedure AddProdPath;
    procedure AddFactor;
    function CanBreakProdPath: boolean;
    procedure AddSetDeclaration;
    procedure AddTokenDeclaration;

    procedure WriteToUses(S: string);
    procedure WriteToGlobal(S: string);
    procedure WriteToPrivate(S: string);
    procedure WriteToProtected(S: string);
    procedure WriteToPublic(S: string);
    procedure WriteToPublished(S: string);
    procedure WriteToCreate(S: string);
    procedure WriteToDestroy(S: string);
    procedure WriteToToken(S: string);
    procedure WriteToProduction(S: string);
    procedure WriteToCharacters(S: string);
    procedure WriteToIgnore(S: string);
    procedure WriteToPragmas(S: string);
    procedure WriteToProdSemanticAction;
    procedure WriteToProdAttributes;
    procedure WriteToFactorSemanticText;
    procedure WriteToFactorAttributes;
    procedure WriteTokenName;
    procedure WriteTokenBody;
    procedure WriteTokenSemanticText;
    procedure WriteCOMPILERFRAME(const S: string);
    procedure WritePARSERFRAME(const S: string);
    procedure WriteSCANNERFRAME(const S: string);
    procedure WriteCOMPILERTARGET(const S: string);
    procedure WritePARSERTARGET(const S: string);
    procedure WriteSCANNERTARGET(const S: string);
    // New Method - 18-03-02
    procedure WriteTargetDirectory(const S: string);
    procedure WriteToFactorClosingPunctuation(const S: string);
    procedure WriteToArbitraryCode(const S: string);
    procedure WriteToSection(const SectID: Integer; S: string);

    property OutputStream: TMemoryStream read fOutputStream write fOutputStream;

    procedure PerformGet;
    procedure SynError(errNo: Integer);
    procedure SemError(errNo: Integer);
    function _In(var s: TSymbolSet; x: Integer): boolean;
    procedure Expect(n: Integer);
    procedure ExpectWeak(n, follow: Integer);
    function WeakSeparator(n, syFol, repFol: Integer): boolean;
    function GetSuccessful: boolean;
    procedure SetSourceString(const Value: string);
    procedure _TokenFactor;
    procedure _TokenTerm;
    procedure _Factor;
    procedure _Term;
    procedure _Symbol;
    procedure _SingleChar;
    procedure _SimSet;
    procedure _Set;
    procedure _TokenExpr;
    procedure _NameDecl;
    procedure _TokenDecl;
    procedure _SetDecl;
    procedure _Expression;
    procedure _SemText;
    procedure _Attribs;
    procedure _Declaration;
    procedure _ClassSection;
    procedure _Ident;
    procedure _pbCocoImportTest;


  protected
    
  public
    
    constructor Create;
    destructor Destroy; override;
    procedure Parse;
    procedure LexString(var Lex: string);
    procedure LexName(var Lex: string);
    procedure LookAheadString(var Lex: string);
    procedure LookAheadName(var Lex: string);
  published
    property Successful: boolean read GetSuccessful;
    property SourceString: string write SetSourceString;
    property Compiler: TCompiler read FCompiler write FCompiler;

  end;

implementation

var
  symSet: array [0..18] of TSymbolSet;
  errDist: integer;
  sym: integer;

procedure TpbCocoImportParser.Init;
begin
  OutputStream.Clear;
  lst.size := 0;
  fAppendReturnCnt := 0;
  fCurrentSection := 0;
  fSpaceCnt := 0;
  fInStartOfProduction := False;
  fCurrentProduction := nil;
  fCurrentProdPath := nil;
  fCurrentFactor := nil;
  fCurrentToken := nil;
  fInFactor := False;
  ResetAttributeFlags;
  fWrapCount := 0;
  fMapTokensToPragmas := False;
  fCOMPILERFRAME := '';
  fPARSERFRAME := '';
  fSCANNERFRAME := '';
  fCOMPILERTARGET := '';
  fPARSERTARGET := '';
  fSCANNERTARGET := '';
  fTargetDirectory := '';
  fClassItemPos := -1; // used when mapping the Delphi Section
end;

procedure TpbCocoImportParser.Final;
begin
  fCompiler.CompilerFrame := Trim(fCompilerFrame);
  fCompiler.CompilerTarget := Trim(fCompilerTarget);
  fCompiler.ParserFrame := Trim(fParserFrame);
  fCompiler.ParserTarget := Trim(fParserTarget);
  fCompiler.ScannerFrame := Trim(fScannerFrame);
  fCompiler.ScannerTarget := Trim(fScannerTarget);
  fCompiler.DelphiSection.UsesClause := Copy(src.DataString,
    fGUITable.useDeclPos.beg, fGUITable.useDeclPos.len) + ';';
  fCompiler.DelphiSection.ArbitraryCodeSection :=
    Copy(src.DataString, fGUITable.ArbitraryCodePos.beg, fGUITable.ArbitraryCodePos.len);
  OutputStream.Position := 0;
  OutputStream.SaveToStream(lst);
  OutputStream.Clear;
end;

procedure TpbCocoImportParser.ResetCollector;
begin
  fCollector := '';
  fClassItemPos := -1;
end;

procedure TpbCocoImportParser.ResetAttributeFlags;
begin
  fIsNoneOrMany := False;
  fIsNoneOrOne := False;
  fIsWrappedInBraces := False;
  fIsBranching := False;
end;

procedure TpbCocoImportParser.CollectLex;
begin
  fCollector := fCollector + GetLexString;
end;

procedure TpbCocoImportParser.WriteToUses(S: string);
begin
  with fCompiler.DelphiSection do
    UsesClause := UsesClause + S;
end;

procedure TpbCocoImportParser.WriteToCreate(S: string);
begin
  with fCompiler.DelphiSection do
    CreateSrc := CreateSrc + S;
end;

procedure TpbCocoImportParser.WriteToDestroy(S: string);
begin
  with fCompiler.DelphiSection do
    DestroySrc := DestroySrc + S;
end;

procedure TpbCocoImportParser.WriteToArbitraryCode(const S: string);
begin
  with fCompiler.DelphiSection do
    ArbitraryCodeSection := ArbitraryCodeSection + S;
end;

procedure TpbCocoImportParser.WriteToGlobal(S: string);
begin
  with fCompiler.DelphiSection do
    TypeDeclarations := TypeDeclarations + S;
end;

procedure TpbCocoImportParser.WriteToPrivate(S: string);
begin
  with fCompiler.DelphiSection do
    PrivateDecs := PrivateDecs + S;
end;

procedure TpbCocoImportParser.WriteToProtected(S: string);
begin
  with fCompiler.DelphiSection do
    ProtectedDecs := ProtectedDecs + S;
end;

procedure TpbCocoImportParser.WriteToPublic(S: string);
begin
  with fCompiler.DelphiSection do
    PublicDecs := PublicDecs + S;
end;

procedure TpbCocoImportParser.WriteToPublished(S: string);
begin
  with fCompiler.DelphiSection do
    PublishedDecs := PublishedDecs + S;
end;

procedure TpbCocoImportParser.WriteToToken(S: string);
begin
  // With fCompiler.DelphiSection do
  // PublishedDecs := PublishedDecs + S;
end;

procedure TpbCocoImportParser.WriteToProduction(S: string);
begin
  // With fCompiler.DelphiSection do
  // PublishedDecs := PublishedDecs + S;
end;

procedure TpbCocoImportParser.WriteToCharacters(S: string);
begin
  // With fCompiler.DelphiSection do
  // PublishedDecs := PublishedDecs + S;
end;

procedure TpbCocoImportParser.WriteToIgnore(S: string);
begin
  // With fCompiler.DelphiSection do
  // PublishedDecs := PublishedDecs + S;
end;

procedure TpbCocoImportParser.WriteToPragmas(S: string);
begin
  // With fCompiler.DelphiSection do
  // PublishedDecs := PublishedDecs + S;
end;

procedure TpbCocoImportParser.WriteToProdSemanticAction;
begin
  Assert(fCurrentProduction <> nil, 'pcBUG: fCurrentProduction = NIL');
  if (fInStartOfProduction) then
  begin
    fCurrentProduction.SemanticAction := Copy(src.DataString, fClassItemPos,
      fClassItemLength);
    ResetCollector;
  end;
end;

procedure TpbCocoImportParser.WriteToProdAttributes;
begin
  fCurrentProduction.Attributes := Copy(src.DataString, fClassItemPos, fClassItemLength);
  ResetCollector;
end;

procedure TpbCocoImportParser.WriteToFactorSemanticText;
begin
  FCurrentFactor.SemanticText := Copy(src.DataString, fClassItemPos, fClassItemLength);
  ResetCollector;
end;

procedure TpbCocoImportParser.WriteToFactorAttributes;
begin
  FCurrentFactor.Attributes := Copy(src.DataString, fClassItemPos, fClassItemLength);
end;

procedure TpbCocoImportParser.WriteTokenName;
begin
  FCurrentToken.Symbol := fCollector;
  ResetCollector;
end;

procedure TpbCocoImportParser.WriteTokenBody;
begin
  FCurrentToken.Expression := fCollector;
  ResetCollector;
end;

procedure TpbCocoImportParser.WriteTokenSemanticText;
begin
  FCurrentToken.SemanticText := Copy(src.DataString, fClassItemPos, fClassItemLength);;
  ResetCollector;
end;

procedure TpbCocoImportParser.WriteToFactorClosingPunctuation(const S: string);
begin
  Assert(FCurrentFactor <> nil, 'pcBug: Dead CurrentFactor.');
  FCurrentFactor.ClosePunctuation := FCurrentFactor.ClosePunctuation + S;
end;

procedure TpbCocoImportParser.IncWrap;
begin
  Inc(fWrapCount);
end;

procedure TpbCocoImportParser.DecWrap;
begin
  if (fWrapCount > 0) then
    Dec(fWrapCount);
end;

procedure TpbCocoImportParser.Skip;
begin
  PerformGet;
end;

procedure TpbCocoImportParser.InTokens;
begin
  fMapTokensToPragmas := False;
end;

procedure TpbCocoImportParser.InPragmas;
begin
  fMapTokensToPragmas := True;
end;

procedure TpbCocoImportParser.WriteToSection(const SectID: Integer; S: string);
begin
  case SectID of
    0: WriteStr(S);
    1: WriteToUses(S);
    2: WriteToGlobal(S);
    3: WriteToPrivate(S);
    4: WriteToProtected(S);
    5: WriteToPublic(S);
    6: WriteToPublished(S);
    7: WriteToCreate(S);
    8: WriteToDestroy(S);
    9: WriteToArbitraryCode(S);
    10: WriteToToken(S);
    11: WriteToProduction(S);
    12: WriteToCharacters(S);
    13: WriteToIgnore(S);
    14: WriteToPragmas(S);
    15: WriteCompilerFrame(S);
    16: WriteParserFrame(S);
    17: WriteScannerFrame(S);
    18: WriteCompilerTarget(S);
    19: WriteParserTarget(S);
    20: WriteScannerTarget(S);
    21: WriteTargetDirectory(S);
    else 
      raise Exception.Create('Writing to a section that does not exist. (' +
        IntToStr(SectID) + ')');
  end; //case
  fSpaceCnt := 0;
  fAppendReturnCnt := 0;
end;

procedure TpbCocoImportParser.WriteSection;
begin
  if (fClassItemPos > 0) then
  begin
    WriteToSection(FCurrentSection, Copy(src.DataString, fClassItemPos, fClassItemLength));
  end
  else
    WriteToSection(FCurrentSection, GetLexString);
end;

procedure TpbCocoImportParser.WriteSpace;
begin
  WriteToSection(FCurrentSection, GetLexString + ' ');
end;

procedure TpbCocoImportParser.WriteStr(S: string);
begin
  OutputStream.WriteBuffer(S[1], length(S));
end;

procedure TpbCocoImportParser.ResetFormatting;
begin
  fClassItemPos := -1;
end;

procedure TpbCocoImportParser.WriteCOMPILERFRAME(const S: string);
begin
  fCOMPILERFRAME := fCOMPILERFRAME + S;
end;

procedure TpbCocoImportParser.WritePARSERFRAME(const S: string);
begin
  fPARSERFRAME := fPARSERFRAME + S;
end;

procedure TpbCocoImportParser.WriteSCANNERFRAME(const S: string);
begin
  fSCANNERFRAME := fSCANNERFRAME + S;
end;

procedure TpbCocoImportParser.WriteCOMPILERTARGET(const S: string);
begin
  fCOMPILERTARGET := fCOMPILERTARGET + S;
end;

procedure TpbCocoImportParser.WritePARSERTARGET(const S: string);
begin
  fPARSERTARGET := fPARSERTARGET + S;
end;

procedure TpbCocoImportParser.WriteSCANNERTARGET(const S: string);
begin
  fSCANNERTARGET := fSCANNERTARGET + S;
end;

procedure TpbCocoImportParser.WriteCollector(const S: string);
begin
  fCollector := fCollector + S;
end;

function TpbCocoImportParser.GetLexString: string;
begin
  LexString(Result);
end;

procedure TpbCocoImportParser.AddProduction(const ProdName: string);
begin
  fCurrentProduction := fCompiler.Productions.AddProduction(ProdName, 'TBD');
  fInStartOfProduction := True;
  fInFactor := False;
end;

procedure TpbCocoImportParser.AddProdPath;
begin
  if (not fInFactor) then
    fCurrentProdPath := fCurrentProduction.AddPath('TBD')
  else
  begin
    fCurrentProdPath := TCocoProductionPath.Create(nil);
    FCurrentFactor.Expression := fCurrentProdPath;
  end;
  fInStartOfProduction := False;
end;

procedure TpbCocoImportParser.AddFactor;
begin
  fCurrentFactor := fCurrentProdPath.AddFactor;

  if (fIsBranching) then
    fCurrentFactor.IsBranching := True;

  if (fIsNoneOrMany) then
  begin
    fCurrentFactor.OpenPunctuation := fCurrentFactor.OpenPunctuation + '{ ';
  end;

  if (fIsNoneOrOne) then
  begin
    fCurrentFactor.OpenPunctuation := fCurrentFactor.OpenPunctuation + '[ ';
  end;

  if (fIsWrappedInBraces) then
  begin
    fCurrentFactor.OpenPunctuation := fCurrentFactor.OpenPunctuation + '( ';
  end;

  ResetAttributeFlags;
end;

procedure TpbCocoImportParser.AddSetDeclaration;
begin
  fCompiler.CharactersSection.AddSet(ReplaceAll(fCollector, #13#10, ''));
end;

function TpbCocoImportParser.CanBreakProdPath: boolean;
begin
  Result := fWrapCount = 0;
end;

procedure TpbCocoImportParser.AddTokenDeclaration;
begin
  if (not fMapTokensToPragmas) then
    fCurrentToken := fCompiler.TokenSection.AddTokenDefinition('TBD')
  else
    fCurrentToken := fCompiler.PragmasSection.AddPragmaDefinition('TBD');
end;

procedure TpbCocoImportParser.WriteTargetDirectory(const S: string);
begin
  fTargetDirectory := fTargetDirectory + S;
end;




 { TpbCocoImportTestParser - Generated Methods }
procedure TpbCocoImportTestParser.SemError(errNo: Integer);
begin
  if errDist >= minErrDist then
  begin
    Error(errNo, line, col, pos);
  end;
  errDist := 0;
end;

procedure TpbCocoImportTestParser.SynError(errNo: Integer);
begin
  if errDist >= minErrDist then
  begin
    Error(errNo, nextLine, nextCol, nextPos);
  end;
  errDist := 0;
end;

procedure TpbCocoImportTestParser.PerformGet;
var
  s: string;
begin
  repeat
    Get(sym);
    if sym <= maxT then
      INC(errDist)
    else
    begin
      case sym of
        61: 
        begin 
          GetName(nextPos + 1, nextLen, s);
          FCompiler.BuildOptions := S; 
        end;
      end;
      nextPos := pos;
      nextCol := col;
      nextLine := line;
      nextLen := len;
    end;
  until sym <= maxT
  end;

function TpbCocoImportTestParser._In(var s: TSymbolSet; x: Integer): boolean;
begin
  _In := x mod setsize in s[x div setsize];
end;

function TpbCocoImportTestParser.GetSuccessful: boolean;
begin
  FSuccessful := errors = 0;
  Result := FSuccessful;
end;

procedure TpbCocoImportTestParser.Expect(n: Integer);
begin
  if Sym = n then PerformGet
  else
    SynError(n);
end;

procedure TpbCocoImportTestParser.ExpectWeak(n, follow: Integer);
begin
  if Sym = n then PerformGet
  else
  begin
    SynError(n);
    while not _In(symSet[follow], Sym) do PerformGet;
  end
end;

function TpbCocoImportTestParser.WeakSeparator(n, syFol, repFol: Integer): boolean;
var
  s: TSymbolSet;
  i: integer;
begin
  if sym = n then
  begin
    PerformGet;
    WeakSeparator := True;
    EXIT;
  end
  else if _In(symSet[repFol], sym) then
  begin
    WeakSeparator := False;
    exit
  end
  else
  begin
    i := 0;
    while i <= maxT div setsize do
    begin
      s[i] := symSet[0, i] + symSet[syFol, i] + symSet[repFol, i];
      INC(i)
    end;
    SynError(n);
    while not _In(s, sym) do PerformGet;
    WeakSeparator := _In(symSet[syFol], sym)
  end
end;

procedure TpbCocoImportTestParser.LexName(var Lex: string);
begin
  GetName(pos, len, Lex)
end;

procedure TpbCocoImportTestParser.LexString(var Lex: string);
begin
  GetString(pos, len, Lex)
end;

procedure TpbCocoImportTestParser.LookAheadName(var Lex: string);
begin
  GetName(nextPos, nextLen, Lex);
end;

procedure TpbCocoImportTestParser.LookAheadString(var Lex: string);
begin
  GetString(nextPos, nextLen, Lex)
end;

procedure TpbCocoImportTestParser.SetSourceString(const Value: string);
begin
  if (src <> nil) then
    src.Free;
  src := TStringStream.Create(Value);
end;

procedure TpbCocoImportTestParser._TokenFactor;
begin
  if (sym = 1) or (sym = 2) then 
  begin
    _Symbol;
    CollectLex;;
  end 
  else if (sym = 44) then 
  begin
    PerformGet;
    CollectLex;;
    _TokenExpr;
    Expect(45);
    CollectLex;;
  end 
  else if (sym = 48) then 
  begin
    PerformGet;
    CollectLex;;
    _TokenExpr;
    Expect(49);
    CollectLex;;
  end 
  else if (sym = 50) then 
  begin
    PerformGet;
    CollectLex;;
    _TokenExpr;
    Expect(51);
    CollectLex;;
  end 
  else 
  begin 
    SynError(61);
  end;
end;

procedure TpbCocoImportTestParser._TokenTerm;
begin
  _TokenFactor;
  while (sym = 1) or (sym = 2) or (sym = 44) or (sym = 48) or (sym = 50) do 
  begin
    _TokenFactor;
  end;
  if (sym = 53) then 
  begin
    PerformGet;
    CollectLex;;
    Expect(44);
    CollectLex;;
    _TokenExpr;
    Expect(45);
    CollectLex;;
  end;
end;

procedure TpbCocoImportTestParser._Factor;
begin
  ResetCollector;
  fInFactor := True;
  AddFactor;;
  case sym of
    1, 2, 47: 
    begin
      if (sym = 47) then 
      begin
        PerformGet;
        fCurrentFactor.IsWeak := True;;
      end;
      _Symbol;
      fCurrentFactor.Symbol := Trim(GetLexString);;
      if (sym = 54) or (sym = 56) then 
      begin
        _Attribs;
        WriteToFactorAttributes;;
      end 
      else if _In(symSet[1], sym) then 
      begin
        ResetCollector;;
      end 
      else 
      begin 
        SynError(62);
      end;
    end;
    44: 
    begin
      PerformGet;
      fIsWrappedInBraces := True;
      IncWrap;;
      _Expression;
      Expect(45);
      DecWrap;
      WriteToFactorClosingPunctuation(') ');;
    end;
    48: 
    begin
      PerformGet;
      fIsNoneOrOne := True;
      IncWrap;;
      _Expression;
      Expect(49);
      DecWrap;
      WriteToFactorClosingPunctuation('] ');;
    end;
    50: 
    begin
      PerformGet;
      fIsNoneOrMany := True;
      IncWrap;;
      _Expression;
      Expect(51);
      DecWrap;
      WriteToFactorClosingPunctuation('} ');;
    end;
    58: 
    begin
      _SemText;
      WriteToFactorSemanticText;;
    end;
    42: 
    begin
      PerformGet;
      fCurrentFactor.IsANY := True;;
    end;
    52: 
    begin
      PerformGet;
      fCurrentFactor.IsSync := True;;
    end;
    else 
    begin 
      SynError(63);
    end;
  end;
  ResetAttributeFlags;;
end;

procedure TpbCocoImportTestParser._Term;
begin
  _Factor;
  while _In(symSet[2], sym) do 
  begin
    _Factor;
  end;
end;

procedure TpbCocoImportTestParser._Symbol;
begin
  if (sym = 1) then 
  begin
    _Ident;
  end 
  else if (sym = 2) then 
  begin
    PerformGet;
  end 
  else 
  begin 
    SynError(64);
  end;
end;

procedure TpbCocoImportTestParser._SingleChar;
begin
  Expect(43);
  fAppendReturnCnt := 0;
  CollectLex;;
  Expect(44);
  CollectLex;;
  if (sym = 4) then 
  begin
    PerformGet;
    CollectLex;;
  end 
  else if (sym = 2) then 
  begin
    PerformGet;
    CollectLex;;
  end 
  else 
  begin 
    SynError(65);
  end;
  Expect(45);
  CollectLex;;
end;

procedure TpbCocoImportTestParser._SimSet;
begin
  if (sym = 1) then 
  begin
    _Ident;
    CollectLex;;
  end 
  else if (sym = 2) then 
  begin
    PerformGet;
    CollectLex;;
  end 
  else if (sym = 43) then 
  begin
    _SingleChar;
    if (sym = 41) then 
    begin
      PerformGet;
      WriteCollector('..');;
      _SingleChar;
    end;
  end 
  else if (sym = 42) then 
  begin
    PerformGet;
    WriteCollector('ANY');;
  end 
  else 
  begin 
    SynError(66);
  end;
end;

procedure TpbCocoImportTestParser._Set;
begin
  _SimSet;
  while (sym = 39) or (sym = 40) do 
  begin
    if (sym = 39) then 
    begin
      PerformGet;
      WriteCollector('+');;
      _SimSet;
    end 
    else 
    begin
      PerformGet;
      WriteCollector('-');;
      _SimSet;
    end;
  end;
end;

procedure TpbCocoImportTestParser._TokenExpr;
begin
  _TokenTerm;
  while WeakSeparator(46, 3, 4) do 
  begin
    CollectLex;;
    _TokenTerm;
  end;
end;

procedure TpbCocoImportTestParser._NameDecl;
begin
  _Ident;
  Expect(12);
  if (sym = 1) then 
  begin
    PerformGet;
  end 
  else if (sym = 2) then 
  begin
    PerformGet;
  end 
  else 
  begin 
    SynError(67);
  end;
  Expect(13);
end;

procedure TpbCocoImportTestParser._TokenDecl;
begin
  ResetCollector;;
  _Symbol;
  CollectLex;
  WriteTokenName;;
  while not ((sym = 12) or (sym = 15)) do 
  begin 
    SynError(68); 
    PerformGet; 
  end;
  Expect(12);
  _TokenExpr;
  Expect(13);
  WriteTokenBody;;
  if (sym = 58) then 
  begin
    _SemText;
    WriteTokenSemanticText;;
  end;
end;

procedure TpbCocoImportTestParser._SetDecl;
begin
  ResetCollector;;
  _Ident;
  WriteCollector(Trim(GetLexString));;
  Expect(12);
  WriteCollector('=');;
  _Set;
  Expect(13);
end;

procedure TpbCocoImportTestParser._Expression;
begin
  AddProdPath;;
  _Term;
  while WeakSeparator(46, 2, 5) do 
  begin
    if (CanBreakProdPath) then
    begin
      fInFactor := False;
      AddProdPath;
    end
    else
      fIsBranching := True;;
    _Term;
  end;
end;

procedure TpbCocoImportTestParser._SemText;
begin
  Expect(58);
  fClassItemPos := nextPos;;
  while _In(symSet[6], sym) do 
  begin
    PerformGet;
    CollectLex;;
  end;
  fClassItemLength := nextPos - fClassItemPos + 1;;
  Expect(59);
end;

procedure TpbCocoImportTestParser._Attribs;
begin
  if (sym = 54) then 
  begin
    ResetCollector;;
    PerformGet;
    fClassItemPos := nextPos + 1;;
    while _In(symSet[7], sym) do 
    begin
      if _In(symSet[8], sym) then 
      begin
        PerformGet;
      end 
      else 
      begin
        PerformGet;
      end;
    end;
    fClassItemLength := nextPos - fClassItemPos + 1;;
    Expect(55);
  end 
  else if (sym = 56) then 
  begin
    PerformGet;
    fClassItemPos := nextPos + 1;;
    while _In(symSet[9], sym) do 
    begin
      if _In(symSet[10], sym) then 
      begin
        PerformGet;
      end 
      else 
      begin
        PerformGet;
      end;
    end;
    fClassItemLength := nextPos - fClassItemPos + 1;;
    Expect(57);
    while _In(symSet[6], sym) do 
    begin
      if _In(symSet[11], sym) then 
      begin
        PerformGet;
      end 
      else if (sym = 3) then 
      begin
        PerformGet;
      end 
      else 
      begin
        PerformGet;
      end;
    end;
    Expect(59);
  end 
  else 
  begin 
    SynError(69);
  end;
end;

procedure TpbCocoImportTestParser._Declaration;
begin
  case sym of
    15: 
    begin
      PerformGet;
      while (sym = 1) do 
      begin
        _SetDecl;
        AddSetDeclaration;;
      end;
    end;
    16: 
    begin
      PerformGet;
      while (sym = 1) or (sym = 2) do 
      begin
        InTokens;
        AddTokenDeclaration;;
        _TokenDecl;
      end;
    end;
    17: 
    begin
      PerformGet;
      while (sym = 1) do 
      begin
        _NameDecl;
      end;
    end;
    18: 
    begin
      PerformGet;
      while (sym = 1) or (sym = 2) do 
      begin
        InPragmas;
        AddTokenDeclaration;;
        _TokenDecl;
      end;
    end;
    19: 
    begin
      PerformGet;
      FCompiler.CocoComments.StartComment;;
      Expect(20);
      FCompiler.CocoComments.StartFrom;
      ResetCollector;;
      _TokenExpr;
      FCompiler.CocoComments.AddCommentText(fCollector);;
      Expect(21);
      FCompiler.CocoComments.StartTO;
      ResetCollector;;
      _TokenExpr;
      FCompiler.CocoComments.AddCommentText(fCollector);;
      if (sym = 22) then 
      begin
        PerformGet;
        FCompiler.CocoComments.StartNested;;
      end 
      else if _In(symSet[12], sym) then 
      begin
        ResetCollector;;
      end 
      else 
      begin 
        SynError(70);
      end;
    end;
    23: 
    begin
      PerformGet;
      if (sym = 24) then 
      begin
        PerformGet;
        FCompiler.IgnoreSection.IgnoreCase := True;;
      end 
      else if (sym = 1) or (sym = 2) or (sym = 42) or (sym = 43) then 
      begin
        ResetCollector;;
        _Set;
        FCompiler.IgnoreSection.IgnoreText := fCollector;;
      end 
      else 
      begin 
        SynError(71);
      end;
    end;
    else 
    begin 
      SynError(72);
    end;
  end;
end;

procedure TpbCocoImportTestParser._ClassSection;
begin
  while _In(symSet[13], sym) do 
  begin
    case sym of
      25: 
      begin
        PerformGet;
        FCurrentSection := 2;;
      end;
      26: 
      begin
        PerformGet;
        FCurrentSection := 3;;
      end;
      27: 
      begin
        PerformGet;
        FCurrentSection := 4;;
      end;
      28: 
      begin
        PerformGet;
        FCurrentSection := 5;;
      end;
      29: 
      begin
        PerformGet;
        FCurrentSection := 6;;
      end;
      30: 
      begin
        PerformGet;
        FCurrentSection := 7;;
      end;
      31: 
      begin
        PerformGet;
        FCurrentSection := 8;;
      end;
      32: 
      begin
        PerformGet;
        FCurrentSection := 15;;
      end;
      33: 
      begin
        PerformGet;
        FCurrentSection := 16;;
      end;
      34: 
      begin
        PerformGet;
        FCurrentSection := 17;;
      end;
      35: 
      begin
        PerformGet;
        FCurrentSection := 18;;
      end;
      36: 
      begin
        PerformGet;
        FCurrentSection := 19;;
      end;
      37: 
      begin
        PerformGet;
        FCurrentSection := 20;;
      end;
      38: 
      begin
        PerformGet;
        FCurrentSection := 21;;
      end;
    end;
    fClassItemPos := nextPos;;
    while _In(symSet[14], sym) do 
    begin
      PerformGet;
    end;
    fClassItemLength := nextPos - fClassItemPos + 1;
    WriteSection;;
  end;
end;

procedure TpbCocoImportTestParser._Ident;
begin
  Expect(1);
end;

procedure TpbCocoImportTestParser._pbCocoImportTest;
var 
  S: string;
begin
  Expect(5);
  Init;;
  _Ident;
  fCompiler.CompilerName := GetLexString;;
  if (sym = 6) then 
  begin
    PerformGet;
    fGUITable.useDeclPos.beg := nextPos;
    fGUITable.hasUses := True;;
    Expect(1);
    while (sym = 7) do 
    begin
      PerformGet;
      Expect(1);
    end;
    fGUITable.useDeclPos.len := nextPos - fGUITable.useDeclPos.beg + 1;
    fGUITable.useDeclPos.col := 0;;
    Expect(8);
  end;
  if (sym = 9) then 
  begin
    PerformGet;
    _ClassSection;
    Expect(10);
    fGUITable.ArbitraryCodePos.beg := nextPos;
  end;
  while _In(symSet[15], sym) do 
  begin
    PerformGet;
  end;
  fGUITable.ArbitraryCodePos.len := nextPos - fGUITable.ArbitraryCodePos.beg;
  fGUITable.ArbitraryCodePos.col := 0;
  while _In(symSet[16], sym) do 
  begin
    _Declaration;
  end;
  while not ((sym = 11) or (sym = 15)) do 
  begin 
    SynError(73); 
    PerformGet; 
  end;
  Expect(11);
  FCurrentSection := 11;;
  while (sym = 1) do 
  begin
    _Ident;
    AddProduction(Trim(GetLexString));;
    if (sym = 54) or (sym = 56) then 
    begin
      _Attribs;
      WriteToProdAttributes;;
    end 
    else if (sym = 12) or (sym = 58) then 
    begin
      ResetCollector;;
    end 
    else 
    begin 
      SynError(74);
    end;
    if (sym = 58) then 
    begin
      _SemText;
      WriteToProdSemanticAction;;
    end;
    ExpectWeak(12, 17);
    _Expression;
    ExpectWeak(13, 18);
  end;
  Expect(14);
  _Ident;
  Expect(13);
  Final;;
end;



procedure TpbCocoImportTestParser.Parse;
begin
  _Reset; 
  PerformGet;
  _pbCocoImportTest;
end;

destructor TpbCocoImportTestParser.Destroy;
begin
  fOutputStream.Free;
  fGUITable.Free;

  inherited;
end;

constructor TpbCocoImportTestParser.Create;
begin
  inherited;
  fOutputStream := TMemoryStream.Create;
  fGUITable := TCocoGUITable.Create;

  errDist := minErrDist;
  symSet[0, 0] := [11, 12, 15];
  symSet[0, 1] := [];
  symSet[0, 2] := [];
  symSet[0, 3] := [];
  symSet[1, 0] := [1, 2, 13];
  symSet[1, 1] := [];
  symSet[1, 2] := [10, 12, 13, 14, 15];
  symSet[1, 3] := [0, 1, 2, 3, 4, 10];
  symSet[2, 0] := [1, 2];
  symSet[2, 1] := [];
  symSet[2, 2] := [10, 12, 15];
  symSet[2, 3] := [0, 2, 4, 10];
  symSet[3, 0] := [1, 2];
  symSet[3, 1] := [];
  symSet[3, 2] := [12];
  symSet[3, 3] := [0, 2];
  symSet[4, 0] := [11, 13, 15];
  symSet[4, 1] := [0, 1, 2, 3, 5, 6, 7];
  symSet[4, 2] := [13];
  symSet[4, 3] := [1, 3];
  symSet[5, 0] := [13];
  symSet[5, 1] := [];
  symSet[5, 2] := [13];
  symSet[5, 3] := [1, 3];
  symSet[6, 0] := [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14];
  symSet[6, 1] := [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15];
  symSet[6, 2] := [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15];
  symSet[6, 3] := [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 12];
  symSet[7, 0] := [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14];
  symSet[7, 1] := [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15];
  symSet[7, 2] := [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15];
  symSet[7, 3] := [0, 1, 2, 3, 4, 5, 6, 8, 9, 10, 11, 12];
  symSet[8, 0] := [0, 1, 2, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14];
  symSet[8, 1] := [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15];
  symSet[8, 2] := [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15];
  symSet[8, 3] := [0, 1, 2, 3, 4, 5, 6, 8, 9, 10, 11, 12];
  symSet[9, 0] := [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14];
  symSet[9, 1] := [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15];
  symSet[9, 2] := [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15];
  symSet[9, 3] := [0, 1, 2, 3, 4, 5, 6, 7, 8, 10, 11, 12];
  symSet[10, 0] := [0, 1, 2, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14];
  symSet[10, 1] := [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15];
  symSet[10, 2] := [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15];
  symSet[10, 3] := [0, 1, 2, 3, 4, 5, 6, 7, 8, 10, 11, 12];
  symSet[11, 0] := [0, 1, 2, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14];
  symSet[11, 1] := [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15];
  symSet[11, 2] := [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15];
  symSet[11, 3] := [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 12];
  symSet[12, 0] := [11, 15];
  symSet[12, 1] := [0, 1, 2, 3, 7];
  symSet[12, 2] := [];
  symSet[12, 3] := [];
  symSet[13, 0] := [];
  symSet[13, 1] := [9, 10, 11, 12, 13, 14, 15];
  symSet[13, 2] := [0, 1, 2, 3, 4, 5, 6];
  symSet[13, 3] := [];
  symSet[14, 0] := [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 11, 12, 13, 14];
  symSet[14, 1] := [0, 1, 2, 3, 4, 5, 6, 7, 8];
  symSet[14, 2] := [7, 8, 9, 10, 11, 12, 13, 14, 15];
  symSet[14, 3] := [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12];
  symSet[15, 0] := [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 12, 13, 14];
  symSet[15, 1] := [4, 5, 6, 8, 9, 10, 11, 12, 13, 14, 15];
  symSet[15, 2] := [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15];
  symSet[15, 3] := [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12];
  symSet[16, 0] := [15];
  symSet[16, 1] := [0, 1, 2, 3, 7];
  symSet[16, 2] := [];
  symSet[16, 3] := [];
  symSet[17, 0] := [1, 2, 11, 12, 15];
  symSet[17, 1] := [];
  symSet[17, 2] := [10, 12, 15];
  symSet[17, 3] := [0, 2, 4, 10];
  symSet[18, 0] := [1, 11, 12, 14, 15];
  symSet[18, 1] := [];
  symSet[18, 2] := [];
  symSet[18, 3] := [];
end;


end.   (* pbCocoImportTestParser *)
