// Generated by ParserBuilder @ 2/05/2002 8:22:47 PM

unit pbSHLScanner;

(* NOTE: Any changes made to this file may be overwritten when it gets regenerated
  from within ParserBuilder *)

interface

uses
  Windows, Messages, SysUtils, Classes;

const
  BlkSize = 16384;
  TAB = #09;
  _LF = #10;
  _CR = #13;
  _EF = #0;
  EF = #0;
  _EL = _CR;
  LineEnds: array[0..2] of char = (#13, #10, #0);
  CRLF = #13#10;

type
  TBufBlock = array [0..BlkSize - 1] of char;
  TCocoBuffer = array [0..1024] of ^TBufBlock;
  TStartTable = array [0..255] of Integer;
  TGetCH = procedure(pos: longint; var retCh: char) of object;
  TCocoErrorProc = procedure(nr, line, col: Integer; pos: Integer) of object;

type
  TpbSHLScanner = class(TObject)
  private
    lastCh,
    ch: char;       (*current input character*)
    curLine: Integer;    (*current input line (may be higher than line)*)
    lineStart: longint;    (*start position of current line*)
    apx: longint;    (*length of appendix (CONTEXT phrase)*)
    oldEols: Integer;    (*number of _EOLs in a comment*)
    bp, bp0: longint;    (*current position in buf
                           (bp0: position of current token)*)
    LBlkSize: longint;    (*BlkSize*)
    inputLen: longint;    (*source file size*)
    buf: TCocoBuffer;     (*source buffer for low-level access*)
    start: TStartTable; (*start state for every character*)
    CurrentCh: TGetCH;
    {----------------}
    FnextLen: Integer;
    Fpos: Integer;
    Fcol: Integer;
    FnextCol: Integer;
    FnextPos: Integer;
    Flen: Integer;
    FnextLine: Integer;
    Fline: Integer;
    Fdirectory: string;
    FError: TCocoErrorProc;
    FOutputDirectory: string;
    procedure Err(nr, line, col: Integer; pos: longint);
    procedure NextCh;
    function Comment: boolean;
    procedure DisposeBuf;
  protected
  public
    src: TStringStream;         (*source/list files. To be opened by the main pgm*)
    lst: TStringStream;
    Ferrors: Integer;
    constructor Create;
    destructor Destroy; override;
    procedure Get(var sym: Integer);
    (* Gets next symbol from source file *)
    procedure GetString(pos: longint; len: Integer; var s: string);
    (* Retrieves exact string of max length len from position pos in source file *)
    procedure GetName(pos: longint; len: Integer; var s: string);
    (* Retrieves name of symbol of length len at position pos in source file *)
    procedure CharAt(pos: longint; var retChar: char);
    (* Returns exact character at position pos in source file *)
    procedure _Reset;
    (* Reads and stores source file internally *)
    property Error: TCocoErrorProc read FError write FError;
  published
    { Published declarations }
    property directory: string read Fdirectory write Fdirectory;
    (*of source file*)
    property OutputDirectory: string read FOutputDirectory write FOutputDirectory;
    property line: Integer read Fline write Fline;
    (*line and column of current symbol*)
    property col: Integer read Fcol write Fcol;
    (*line and column of current symbol*)
    property len: Integer read Flen write Flen;      (*length of current symbol*)
    property pos: Integer read Fpos write Fpos;
    (*file position of current symbol*)
    property nextLine: Integer read FnextLine write FnextLine;
    (*line of lookahead symbol*)
    property nextCol: Integer read FnextCol write FnextCol;
    (*column of lookahead symbol*)
    property nextLen: Integer read FnextLen write FnextLen;
    (*length of lookahead symbol*)
    property nextPos: Integer read FnextPos write FnextPos;
    (*file position of lookahead symbol*)
    property errors: Integer read Ferrors write Ferrors;
    (*number of detected errors*)
  end;


implementation



const
  no_Sym = 36; (*error token code*)
  (* not only for errors but also for not finished states of scanner analysis *)
  _EOF = #26; (*MS-DOS _EOF*)

procedure TpbSHLScanner.CharAt(pos: longint; var retChar: char);
var
  ch: char;
begin
  if pos >= inputLen then
  begin
    retChar := EF;
    EXIT;
  end;
  ch := buf[pos div LBlkSize]^[pos mod LBlkSize];
  if ch <> _EOF then retChar := ch
  else
    retChar := EF
end;

function TpbSHLScanner.Comment: boolean;
begin
  Comment := False;
end;


procedure TpbSHLScanner.Err(nr, line, col, pos: Integer);
begin
  INC(Ferrors)
end;

procedure TpbSHLScanner.Get(var sym: Integer);
var
  state: integer;

  function Equal(s: string): boolean;
  var
    i: integer;
    q: longint;
    cc: char; // Current Char returned from modifed TGetCh
  begin
    if nextLen <> Length(s) then
    begin
      Equal := False;
      EXIT
    end;
    i := 1;
    q := bp0;
    while i <= nextLen do
    begin
      CurrentCh(q, cc);
      if cc <> s[i] then
      begin
        Equal := False;
        EXIT
      end;
      INC(i);
      INC(q)
    end;
    Equal := True
  end;

  procedure CheckLiteral;
  var 
    cc: char;
  begin
    CurrentCh(bp0, cc);
    case cc of
    
      '(': if Equal('(.') then 
        begin 
          sym := 32; 
          end;
    
      '.': if Equal('.)') then 
        begin 
          sym := 33; 
          end;
    
      'C': if Equal('CHARACTERS') then 
        begin 
          sym := 6; 
          end 
        else if Equal('COMMENTS') then 
        begin 
          sym := 10; 
          end 
        else if Equal('COMPILER') then 
        begin 
          sym := 16; 
          end 
        else if Equal('COMPILERFRAME') then 
        begin 
          sym := 28; 
          end 
        else if Equal('CREATE') then 
        begin 
          sym := 23; 
          end;
    
      'D': if Equal('DELPHI') then 
        begin 
          sym := 17; 
          end 
        else if Equal('DESTROY') then 
        begin 
          sym := 24; 
          end;
    
      'E': if Equal('END_DELPHI') then 
        begin 
          sym := 18; 
          end 
        else if Equal('ERRORS') then 
        begin 
          sym := 26; 
          end;
    
      'F': if Equal('FROM') then 
        begin 
          sym := 11; 
          end;
    
      'G': if Equal('GLOBAL') then 
        begin 
          sym := 27; 
          end;
    
      'I': if Equal('IGNORE') then 
        begin 
          sym := 15; 
          end;
    
      'N': if Equal('NAMES') then 
        begin 
          sym := 8; 
          end 
        else if Equal('NESTED') then 
        begin 
          sym := 14; 
          end;
    
      'P': if Equal('PARSERFRAME') then 
        begin 
          sym := 29; 
          end 
        else if Equal('PRAGMAS') then 
        begin 
          sym := 9; 
          end 
        else if Equal('PRIVATE') then 
        begin 
          sym := 19; 
          end 
        else if Equal('PRODUCTIONS') then 
        begin 
          sym := 13; 
          end 
        else if Equal('PROTECTED') then 
        begin 
          sym := 20; 
          end 
        else if Equal('PUBLIC') then 
        begin 
          sym := 21; 
          end 
        else if Equal('PUBLISHED') then 
        begin 
          sym := 22; 
          end;
    
      'S': if Equal('SCANNERFRAME') then 
        begin 
          sym := 30; 
          end;
    
      'T': if Equal('TARGETDIRECTORY') then 
        begin 
          sym := 31; 
          end 
        else if Equal('TO') then 
        begin 
          sym := 12; 
          end 
        else if Equal('TOKENS') then 
        begin 
          sym := 7; 
          end;
    
      'U': if Equal('USES') then 
        begin 
          sym := 25; 
          end;
    
      else 
      begin 
      end
    end
  end;
begin (*Get*)
  if oldEols > 0 then 
  begin 
    DEC(bp); 
    DEC(oldEols); 
    ch := _CR 
  end;
  
  while (ch = ' ') or
        
    ((ch >= CHR(1)) and (ch <= CHR(12)) or
        
    (ch >= CHR(14)) and (ch <= CHR(31))) do NextCh;
  pos := nextPos;
  nextPos := bp;
  col := nextCol;
  nextCol := bp - lineStart;
  line := nextLine;
  nextLine := curLine;
  len := nextLen;
  nextLen := 0;
  apx := 0;
  state := start[Ord(ch)];
  bp0 := bp;
  while True do
  begin
    NextCh;
    INC(FnextLen);
    case state of
      1: if ((ch = '!') or
             
          (ch >= '#') and (ch <= '$') or
             
          (ch >= '(') and (ch <= '*') or
             
          (ch = '.') or
             
          (ch >= '0') and (ch <= '9') or
             
          (ch >= '@') and (ch <= '{') or
             
          (ch >= '}')) then 
        begin            
        end 
        else 
        begin 
          sym := 1; 
          CheckLiteral; 
          EXIT; 
        end;
     
      2: 
      begin 
        sym := 2; 
        EXIT; 
      end;
     
      3: 
      begin 
        sym := 3; 
        EXIT; 
      end;
     
      4: if ((ch = ' ')) then 
        begin            
        end 
        else 
        begin 
          sym := 4; 
          EXIT; 
        end;
     
      5: if ((ch = CHR(13)) or
             
          (ch = '"')) then 
        begin 
          state := 7; 
        end 
        else if ((ch <= CHR(12)) or
                
          (ch >= CHR(14)) and (ch <= '!') or
                
          (ch >= '#')) then 
        begin            
        end 
        else 
        begin 
          sym := no_Sym; 
          EXIT; 
        end;
     
      6: if ((ch = CHR(13)) or
             
          (ch = CHR(39))) then 
        begin 
          state := 7; 
        end 
        else if ((ch <= CHR(12)) or
                
          (ch >= CHR(14)) and (ch <= '&') or
                
          (ch >= '(')) then 
        begin            
        end 
        else 
        begin 
          sym := no_Sym; 
          EXIT; 
        end;
     
      7: 
      begin 
        sym := 5; 
        EXIT; 
      end;
     
      8: if ((ch = CHR(13)) or
             
          (ch = '"')) then 
        begin 
          state := 7; 
        end 
        else if ((ch <= CHR(12)) or
                
          (ch >= CHR(14)) and (ch <= '!') or
                
          (ch >= '#')) then 
        begin 
          state := 5; 
        end 
        else 
        begin 
          sym := 3; 
          EXIT; 
        end;
     
      9: if ((ch = CHR(13)) or
             
          (ch = CHR(39))) then 
        begin 
          state := 7; 
        end 
        else if ((ch <= CHR(12)) or
                
          (ch >= CHR(14)) and (ch <= '&') or
                
          (ch >= '(')) then 
        begin 
          state := 6; 
        end 
        else 
        begin 
          sym := 3; 
          EXIT; 
        end;
     
      10: 
      begin 
        sym := 34; 
        EXIT; 
      end;
     
      11: 
      begin 
        sym := 35; 
        EXIT; 
      end;
     
      12: if (ch = '>') then 
        begin 
          state := 10; 
        end 
        else 
        begin 
          sym := 3; 
          EXIT; 
        end;
     
      13: if (ch = '<') then 
        begin 
          state := 11; 
        end 
        else 
        begin 
          sym := 3; 
          EXIT; 
        end;
     
      14: 
      begin 
        sym := 0; 
        ch := #0; 
        DEC(bp); 
        EXIT 
      end;
      else
      begin
        sym := no_Sym;
        EXIT (*NextCh already done*)
      end;
    end
  end
end;


procedure TpbSHLScanner.GetName(pos, len: Integer; var s: string);
var
  i: integer;
  p: longint;
  cc: char;
begin
  if len > 255 then len := 255;
  p := pos;
  i := 1;
  SetLength(S, Len);
  while i <= len do
  begin
    CurrentCh(p, cc);
    s[i] := cc;
    INC(i);
    INC(p)
  end;
end;


procedure TpbSHLScanner.GetString(pos, len: Integer; var s: string);
var
  i: integer;
  p: longint;
  cc: char;
begin
  if len > 255 then len := 255;
  p := pos;
  i := 1;
  setLength(S, len);
  while i <= len do
  begin
    CharAt(p, cc);
    s[i] := cc;
    INC(i);
    INC(p)
  end;
end;

procedure TpbSHLScanner.NextCh;
  (* Return global variable ch *)
var 
  cc: char;
begin
  lastCh := ch;
  INC(bp);
  CurrentCh(bp, cc);
  ch := cc;
  if (ch = _EL) or (ch = _LF) and (lastCh <> _EL) then
  begin
    INC(curLine);
    lineStart := bp
  end
end;


procedure TpbSHLScanner._Reset;
var
  len: longint;
  i, Read: integer;
  AmtTransferred: integer;
begin (*assert: src has been opened*)
  //  len := FileSize(src);
  Len := src.Size;
  DisposeBuf;
  i := 0;
  inputLen := len;
  while len > LBlkSize do
  begin
    NEW(buf[i]);
    Read := BlkSize;
    //    BlockRead(src, buf[i]^, Read,AmtTransferred);
    AmtTransferred := src.Read(buf[i]^, Read);
    len := len - AmtTransferred;
    INC(i)
  end;
  NEW(buf[i]);
  Read := len;
  //AmtTransferred :=
  src.Read(buf[i]^, Read);
  buf[i]^[Read] := EF;
  curLine := 1;
  lineStart := -2;
  bp := -1;
  oldEols := 0;
  apx := 0;
  errors := 0;
  NextCh;
end;

constructor TpbSHLScanner.Create;
begin
  inherited;
  lst := TStringStream.Create('');
  src := nil;
  CurrentCh := CharAt;
  
  start[0] := 14; 
  start[1] := 15; 
  start[2] := 15; 
  start[3] := 15; 
  
  start[4] := 15; 
  start[5] := 15; 
  start[6] := 15; 
  start[7] := 15; 
  
  start[8] := 15; 
  start[9] := 15; 
  start[10] := 15; 
  start[11] := 15; 
  
  start[12] := 15; 
  start[13] := 2; 
  start[14] := 15; 
  start[15] := 15; 
  
  start[16] := 15; 
  start[17] := 15; 
  start[18] := 15; 
  start[19] := 15; 
  
  start[20] := 15; 
  start[21] := 15; 
  start[22] := 15; 
  start[23] := 15; 
  
  start[24] := 15; 
  start[25] := 15; 
  start[26] := 15; 
  start[27] := 15; 
  
  start[28] := 15; 
  start[29] := 15; 
  start[30] := 15; 
  start[31] := 15; 
  
  start[32] := 4; 
  start[33] := 1; 
  start[34] := 8; 
  start[35] := 1; 
  
  start[36] := 1; 
  start[37] := 3; 
  start[38] := 3; 
  start[39] := 9; 
  
  start[40] := 1; 
  start[41] := 1; 
  start[42] := 1; 
  start[43] := 12; 
  
  start[44] := 3; 
  start[45] := 13; 
  start[46] := 1; 
  start[47] := 3; 
  
  start[48] := 1; 
  start[49] := 1; 
  start[50] := 1; 
  start[51] := 1; 
  
  start[52] := 1; 
  start[53] := 1; 
  start[54] := 1; 
  start[55] := 1; 
  
  start[56] := 1; 
  start[57] := 1; 
  start[58] := 3; 
  start[59] := 3; 
  
  start[60] := 3; 
  start[61] := 3; 
  start[62] := 3; 
  start[63] := 3; 
  
  start[64] := 1; 
  start[65] := 1; 
  start[66] := 1; 
  start[67] := 1; 
  
  start[68] := 1; 
  start[69] := 1; 
  start[70] := 1; 
  start[71] := 1; 
  
  start[72] := 1; 
  start[73] := 1; 
  start[74] := 1; 
  start[75] := 1; 
  
  start[76] := 1; 
  start[77] := 1; 
  start[78] := 1; 
  start[79] := 1; 
  
  start[80] := 1; 
  start[81] := 1; 
  start[82] := 1; 
  start[83] := 1; 
  
  start[84] := 1; 
  start[85] := 1; 
  start[86] := 1; 
  start[87] := 1; 
  
  start[88] := 1; 
  start[89] := 1; 
  start[90] := 1; 
  start[91] := 1; 
  
  start[92] := 1; 
  start[93] := 1; 
  start[94] := 1; 
  start[95] := 1; 
  
  start[96] := 1; 
  start[97] := 1; 
  start[98] := 1; 
  start[99] := 1; 
  
  start[100] := 1; 
  start[101] := 1; 
  start[102] := 1; 
  start[103] := 1; 
  
  start[104] := 1; 
  start[105] := 1; 
  start[106] := 1; 
  start[107] := 1; 
  
  start[108] := 1; 
  start[109] := 1; 
  start[110] := 1; 
  start[111] := 1; 
  
  start[112] := 1; 
  start[113] := 1; 
  start[114] := 1; 
  start[115] := 1; 
  
  start[116] := 1; 
  start[117] := 1; 
  start[118] := 1; 
  start[119] := 1; 
  
  start[120] := 1; 
  start[121] := 1; 
  start[122] := 1; 
  start[123] := 1; 
  
  start[124] := 3; 
  start[125] := 1; 
  start[126] := 1; 
  start[127] := 1; 
  
  start[128] := 1; 
  start[129] := 1; 
  start[130] := 1; 
  start[131] := 1; 
  
  start[132] := 1; 
  start[133] := 1; 
  start[134] := 1; 
  start[135] := 1; 
  
  start[136] := 1; 
  start[137] := 1; 
  start[138] := 1; 
  start[139] := 1; 
  
  start[140] := 1; 
  start[141] := 1; 
  start[142] := 1; 
  start[143] := 1; 
  
  start[144] := 1; 
  start[145] := 1; 
  start[146] := 1; 
  start[147] := 1; 
  
  start[148] := 1; 
  start[149] := 1; 
  start[150] := 1; 
  start[151] := 1; 
  
  start[152] := 1; 
  start[153] := 1; 
  start[154] := 1; 
  start[155] := 1; 
  
  start[156] := 1; 
  start[157] := 1; 
  start[158] := 1; 
  start[159] := 1; 
  
  start[160] := 1; 
  start[161] := 1; 
  start[162] := 1; 
  start[163] := 1; 
  
  start[164] := 1; 
  start[165] := 1; 
  start[166] := 1; 
  start[167] := 1; 
  
  start[168] := 1; 
  start[169] := 1; 
  start[170] := 1; 
  start[171] := 1; 
  
  start[172] := 1; 
  start[173] := 1; 
  start[174] := 1; 
  start[175] := 1; 
  
  start[176] := 1; 
  start[177] := 1; 
  start[178] := 1; 
  start[179] := 1; 
  
  start[180] := 1; 
  start[181] := 1; 
  start[182] := 1; 
  start[183] := 1; 
  
  start[184] := 1; 
  start[185] := 1; 
  start[186] := 1; 
  start[187] := 1; 
  
  start[188] := 1; 
  start[189] := 1; 
  start[190] := 1; 
  start[191] := 1; 
  
  start[192] := 1; 
  start[193] := 1; 
  start[194] := 1; 
  start[195] := 1; 
  
  start[196] := 1; 
  start[197] := 1; 
  start[198] := 1; 
  start[199] := 1; 
  
  start[200] := 1; 
  start[201] := 1; 
  start[202] := 1; 
  start[203] := 1; 
  
  start[204] := 1; 
  start[205] := 1; 
  start[206] := 1; 
  start[207] := 1; 
  
  start[208] := 1; 
  start[209] := 1; 
  start[210] := 1; 
  start[211] := 1; 
  
  start[212] := 1; 
  start[213] := 1; 
  start[214] := 1; 
  start[215] := 1; 
  
  start[216] := 1; 
  start[217] := 1; 
  start[218] := 1; 
  start[219] := 1; 
  
  start[220] := 1; 
  start[221] := 1; 
  start[222] := 1; 
  start[223] := 1; 
  
  start[224] := 1; 
  start[225] := 1; 
  start[226] := 1; 
  start[227] := 1; 
  
  start[228] := 1; 
  start[229] := 1; 
  start[230] := 1; 
  start[231] := 1; 
  
  start[232] := 1; 
  start[233] := 1; 
  start[234] := 1; 
  start[235] := 1; 
  
  start[236] := 1; 
  start[237] := 1; 
  start[238] := 1; 
  start[239] := 1; 
  
  start[240] := 1; 
  start[241] := 1; 
  start[242] := 1; 
  start[243] := 1; 
  
  start[244] := 1; 
  start[245] := 1; 
  start[246] := 1; 
  start[247] := 1; 
  
  start[248] := 1; 
  start[249] := 1; 
  start[250] := 1; 
  start[251] := 1; 
  
  start[252] := 1; 
  start[253] := 1; 
  start[254] := 1; 
  start[255] := 1; 
  Error := Err;
  LBlkSize := BlkSize;
  lastCh := EF;
end;

destructor TpbSHLScanner.Destroy;
begin
  if (src <> nil) then
    src.Free;
  lst.Free;
  DisposeBuf;
  inherited;
end;

procedure TpbSHLScanner.DisposeBuf;
var
  idx: integer;
begin
  for idx := 1024 downto 0 do
  begin
    if buf[idx] <> nil then
      Dispose(buf[idx]);
    buf[idx] := nil;
  end;
end;



end.
